Class(IPv6Neighbors).Extends(RT_BP)
IPv6Neighbors.ACTION_DELETE_STATIC="deleteAllStatic";
IPv6Neighbors.ACTION_DELETE_DYNAMIC="deleteAllDynamic";
IPv6Neighbors.ACTION_DELETE_ALL="deleteAll";
function IPv6Neighbors()
{
this.konstructor = function(master)
{
this.superclass(master);
this.IPv6Interface=this.setIPv6Interface();
this.groupTable = new RT(Page.findNodeByUniqID("oIPv6Neighbors"));
this.total=IXML.getText(Page.dataXml.selectSingleNode("//IPv6NeighborList/entryCount"));
};
this.localizationInit = function()
{
var lastRecord=oIPv6NeighborsPaging.getLastRecord(this.total);
this.pgTkn = new projTknObj('2550','IPv6Neighbors');
this.pgTkn.createLocalizedGWPagingLables("2550015","lblTblCaption",oIPv6NeighborsPaging.type,oIPv6NeighborsPaging.firstEntryInPage,lastRecord,this.total,"oIPv6NeighborsPaging.pagingFilter()");
this.pgTkn.setTokenWithError('lblHdrInterface', '2550016');
this.pgTkn.setTokenWithError('lblHdrIPAddr', '2550017');
this.pgTkn.setTokenWithError('lblHdrMACAddr', '2550018');
this.pgTkn.setTokenWithError('lblHdrType', '2550019');
this.pgTkn.setTokenWithError('lblHdrState', '2550020');
this.pgTkn.setTokenWithError('oIPv6Neighbors_emptyCell', '10998');
this.pgTkn.createLocalizedLabel("", "left", "rdoClearTblStat", "lblClearTable", false, "2550021", null, "tdClearTable");
this.pgTkn.createLocalizedLabel("", "", "rdoClearTblStat", "lblRdoStat", false, "2550012", null, "tdLblRdoStat");
this.pgTkn.createLocalizedLabel("", "", "rdoClearTblDyn", "lblRdoDyn", false, "2550013", null, "tdLblRdoDyn");
this.pgTkn.createLocalizedLabel("", "", "rdoClearTblAll", "lblRdoAll", false, "2550014", null, "tdLblRdoAll");
this.pgTkn.CreateLocalizedButtonShortDefault('10004', 'oIPv6Neighbors.clearTable()', 'defaultButton', 'tdApply');
this.pgTkn.CreateLocalizedButtonReset('btnCancel', 'gwReset', 'tdCancel', 'oIPv6Neighbors.pgTkn');
this.pgTkn.CreateLocalizedButtonShort('10001','OpenModalDialog(\'../GW/PopUp.htm?Add\')','btnAdd','tdBtnAdd',"10053");
this.pgTkn.CreateLocalizedButtonShort('10002','oIPv6Neighbors.modify()','btnEdt','tdBtnEdit');
this.pgTkn.CreateLocalizedButtonShort('10003','oIPv6Neighbors.deleteNeighbors()','btnDel','tdBtnDelete');
this.pgTkn.createLocalizedBackNextWithPager("oIPv6NeighborsPaging.getPrev()","oIPv6NeighborsPaging.getNext()","btnBack","btnNext",(oIPv6NeighborsPaging.pageSize-1),this.total,oIPv6NeighborsPaging.urlCache.length,"tdBtnPaging");
this.AlterPagingButtonsDisabling();
AlterButtonDisabling('btnEdt', true);
AlterButtonDisabling('btnDel', true);
this.pgTkn.setTokenAttribute('btnEdt','title','11011');
this.pgTkn.setTokenAttribute('btnDel','title','11011');
this.pgTkn.setTokenWithError("IPv6Neighbor_M_CB", "", [[TKN_CALLBACK, function(){oIPv6Neighbors.LocalizeTableData()}]]);
this.pgTkn.setTokenWithError("pageHeader", _top.document.getElementById("caption").innerHTML);
this.displayNames();
}
this.displayNames = function()
{
var rows = this.xmlData.selectNodes("//tr[@BIND and contains(@ID,'r')]");
var row_id,html_row,interfaceName,targetCell,ifIndex;
for(var i=0;i<rows.length;i++)
{
row_id = rows[i].getAttribute("ID");
html_row = document.getElementById(row_id);
targetCell = html_row.getElementsByTagName("td")[1];
interfaceName=IXML.getText(rows[i].selectNodes('./td')[9]);
ifIndex=_top.getPortNumberFromName(interfaceName);
targetCell.innerHTML = (ifIndex<_top.trunkFirstIndex)?_top.getPortName(interfaceName,true):interfaceName;
}
}
this.AlterPagingButtonsDisabling = function()
{
if(oIPv6NeighborsPaging.urlCache.length==1)
{
this.pgTkn.AlterButtonBackNextTransDisabling("btnBack", true, "");
this.pgTkn.setTokenAttribute("btnBack","title","11014");
}
if(Page.dataXml.selectNodes("//IPv6NeighborList/NeighborEntry").length<oIPv6NeighborsPaging.pageSize)
{
this.pgTkn.AlterButtonBackNextTransDisabling("btnNext", true, "");
this.pgTkn.setTokenAttribute("btnNext","title","11015");
}
else
{
var id=this.groupTable.xmlData.selectSingleNode("//tr[position()="+oIPv6NeighborsPaging.pageSize+"]").getAttribute("ID");
document.getElementById(id).style.display="none";
document.getElementById(id).getElementsByTagName("input")[0].disabled=true;
}
}
this.setIPv6Interface = function()
{
var IPv6Interf=Page.dataXml.selectSingleNode("//IPv6InterfaceList/InterfaceEntry/interfaceName");
if(IPv6Interf)
return IXML.getText(IPv6Interf);
else
return "";
};
this.getIPv6Interface = function()
{
return this.IPv6Interface;
};
this.checkIfCanBeChanged = function(type)
{
if(type=="Delete" || type=="Apply")
{
var rows=this.xmlData.selectNodes("//tr[@BIND and contains(@ID,'r')]");
if(rows.length>0)
return true;
else
{
alert("Neighbors can't be deleted since there are no records.");
return false;
}
}
else if(type=="Add")
{
if(this.IPv6Interface!="")
return true;
else
{
alert("New neighbor can't be added since there is no IPv6 interface.");
return false;
}
}
return true;
};
this.deleteNeighbors = function()
{
HideSelectedRows("selRow");
this.deleteEntry();
Page.save();
Page.send();
};
this.clearTable = function()
{
var clearTable;
var action="";
if(getElement("rdoClearTblStat").checked)
clearTable = "1";
else if(getElement("rdoClearTblAll").checked)
clearTable = "3";
else
clearTable = "2";
switch(clearTable)
{
case "1":
action=IPv6Neighbors.ACTION_DELETE_STATIC;
break;
case "2":
action=IPv6Neighbors.ACTION_DELETE_DYNAMIC;
break;
case "3":
action=IPv6Neighbors.ACTION_DELETE_ALL;
break;
}
this.send(action);
};
this.createPostXML = function(action)
{
var dataSectionName="IPv6NeighborList";
var sectionNode;
sectionNode = IXML.getDomDocument(null,dataSectionName);
sectionNode = sectionNode.selectSingleNode("//" + dataSectionName);
if(sectionNode)sectionNode.setAttribute("action",action)
return sectionNode;
};
this.send = function(action)
{
if( action==IPv6Neighbors.ACTION_DELETE_STATIC ||
action==IPv6Neighbors.ACTION_DELETE_DYNAMIC ||
action==IPv6Neighbors.ACTION_DELETE_ALL)
{
if(PageManager.IS_MOCKUP)return;
var async=true;
var posted_xml;
posted_xml=this.createPostXML(action);
Page.post(posted_xml,async,action);
}
else
this.superclass();
};
this.modify = function()
{
var obj = GetSelectedCtrl("selRow");
RT.activeID = "oIPv6Neighbors";
var id = RT.findIndex(RT.activeID);
if (null == id || RT.collRT == null)
return;
var row = IXML.getContainer(obj, "tr");
RT.collRT[id][1].selectRow(row, row.className);
OpenModalDialog("../GW/PopUp.htm?Edit");
};
this.LocalizeTableData = function()
{
Page.localize();
RT.localize("oIPv6Neighbors", "span_4_");
RT.localize("oIPv6Neighbors", "span_6_");
}
};
var oIPv6Neighbors;
IPv6Neighbors.create = function(id)
{
oIPv6Neighbors = new IPv6Neighbors(Page.findNodeByUniqID(id));
if(oIPv6Neighbors.masterNode.attributes.getNamedItem("PAGING_ID")){
if (oIPv6NeighborsPaging && top.savePagingObj) {
oIPv6NeighborsPaging.scope=oIPv6Neighbors;
oIPv6Neighbors.url=oIPv6NeighborsPaging.urlCache[oIPv6NeighborsPaging.urlCache.length-1]
oIPv6Neighbors.get();
}
else {
oIPv6NeighborsPaging = new IPv6NeighborsPaging(oIPv6Neighbors.masterNode.getAttribute("PAGING_ID"),oIPv6Neighbors);
oIPv6NeighborsPaging.init();
oIPv6NeighborsPaging.getPrev();
}
top.savePagingObj=false;
Page.subscribe('oIPv6NeighborsPaging');
}
Page.subscribe('oIPv6Neighbors','RT');
};
var oIPv6NeighborsPaging;
Class(IPv6NeighborsPaging).Extends(PrevNextPaging);
function IPv6NeighborsPaging(){
this.konstructor=function(id,scope){
this.superclass(id,scope);
};
this.getNext=function(){
if(this.scope.xmlData && this.scope.cntRows && this.scope.cntRows >=this.pageSize){
var ipNetToPhysicalIfIndex = this.scope.xmlData.selectSingleNode("//tr[position()="+this.pageSize+"]").selectSingleNode(".//*[@BIND='interfaceName']").getAttribute("VALUE");
var ipNetToPhysicalNetAddress = this.scope.xmlData.selectSingleNode("//tr[position()="+this.pageSize+"]").selectSingleNode(".//*[@BIND='IPv6Address']").getAttribute("VALUE");
this.createUrl(ipNetToPhysicalIfIndex.toString(),ipNetToPhysicalNetAddress.toString());
this.scope.url=this.urlCache[this.urlCache.length-1];
this.scope.get();
}
};
this.createUrl=function(ipNetToPhysicalIfIndex,ipNetToPhysicalNetAddress){
var url="";
if(ipNetToPhysicalIfIndex=="" || !ipNetToPhysicalIfIndex)
url = "wcd?{IPv6NeighborList&entryCount=en&Count=" + this.pageSize + "}{IPv6InterfaceList&filter=(interfaceType!=4)}";
else
{
url = this.urlTemplate.replace("#interfaceName#",ipNetToPhysicalIfIndex).replace("#IPv6Address#",ipNetToPhysicalNetAddress).replace("#COUNT#",this.pageSize);
this.firstEntryInPage=((this.urlCache.length)*(this.pageSize-1))+1;
}
if (this.scope.total==0)
this.firstEntryInPage=0;
this.urlCache.push(url);
};
};
