Class(IPv6BasedACL).Extends(RT_BP)
function IPv6BasedACL()
{
this.konstructor=function(master)
{
this.superclass(master);
this.acl = "";
this.groupTable = new RT(Page.findNodeByUniqID("oIPv6BasedACL"));
this.total=IXML.getText(Page.dataXml.selectSingleNode("//ACLRuleList/entryCount"));
if (this.total==0 && oIPv6BasedACLPaging)
oIPv6BasedACLPaging.firstEntryInPage=0;
this.transform();
};
this.initLocalization = function()
{
this.pgTkn = new projTknObj('3080','IPv6ACE_m');
this.applyLocalizationTokens();
}
this.applyLocalizationTokens = function()
{
var lastRecord=oIPv6BasedACLPaging.getLastRecord(this.total);
this.pgTkn.createLocalizedGWPagingLables("3080026","lblCaption",oIPv6BasedACLPaging.type,oIPv6BasedACLPaging.firstEntryInPage,lastRecord,this.total,"oIPv6BasedACLPaging.pagingFilter()");
this.pgTkn.createLocalizedBackNextWithPager("oIPv6BasedACLPaging.getPrev()","oIPv6BasedACLPaging.getNext()","btnBack","btnNext",(oIPv6BasedACLPaging.pageSize-1),this.total,oIPv6BasedACLPaging.urlCache.length,"tdBtnPaging");
this.AlterPagingButtonsDisabling();
this.pgTkn.setTokenWithError("lblPriority", "3080028");
this.pgTkn.setTokenWithError("lblProtocol", "3080029");
this.pgTkn.setTokenWithError("lblSrcPort", "3080030");
this.pgTkn.setTokenWithError("lblDestPort", "3080031");
this.pgTkn.setTokenWithError("lblFlagSet", "3080032");
this.pgTkn.setTokenWithError("lblIcmpType", "3080033");
this.pgTkn.setTokenWithError("lblIcmpCode", "3080034");
this.pgTkn.setTokenWithError("lblIPSrcCap", "3080035");
this.pgTkn.setTokenWithError("lblIPDstCap", "3080036");
this.pgTkn.setTokenWithError("lblDSCP", "3080037");
this.pgTkn.setTokenWithError("lblIPPreced", "3080038");
this.pgTkn.setTokenWithError("lblAction", "3080041");
this.pgTkn.setTokenWithError("lblIPSrcAddr", "3080042");
this.pgTkn.setTokenWithError("lblIPSrcPref", "3080043");
this.pgTkn.setTokenWithError("lblIPDstAddr", "3080044");
this.pgTkn.setTokenWithError("lblIPDstPref", "3080045");
this.pgTkn.setTokenWithError("lblTblFootnote", "3080046");
this.pgTkn.createLocalizedFilterLabelGW("1", "cmbACL", "lblFilter", "tdLblFilter","3080027");
this.pgTkn.CreateLocalizedTableHeaderButton("10061", "oIPv6BasedACL.buildIPv6BasedAclUrl();", "btnGo","tdBtnGo");
this.pgTkn.CreateLocalizedButtonShort('10001','OpenModalDialog(\'../GW/PopUp.htm?Add_Rule\')','btnAdd','tdBtnAdd',"10053");
this.pgTkn.CreateLocalizedButtonShort('10002','OpenModalDialog(\'../GW/PopUp.htm?Edit\')','btnEdit','tdBtnEdit');
this.pgTkn.CreateLocalizedButtonShort('10003','oIPv6BasedACL.deleteRule();','btnDel','tdBtnDel');
this.pgTkn.CreateLocalizedButtonShort('10045','oIPv6BasedACL.goToACLScreen();','btnACL','tdBtnACL');
AlterButtonDisabling('btnEdit', true);
AlterButtonDisabling('btnDel', true);
this.pgTkn.setTokenAttribute('btnEdit','title','11000');
this.pgTkn.setTokenAttribute('btnDel','title','11000');
this.pgTkn.setTokenWithError("IPv6ACL_M_CB", "", [[TKN_CALLBACK, function(){oIPv6BasedACL.LocalizeTableData()}]]);
this.pgTkn.setTokenWithError("pageHeader", _top.document.getElementById("caption").innerHTML);
this.pgTkn.setTokenWithError("oIPv6BasedACL_emptyCell","10998");
this.update_get();
}
this.AlterPagingButtonsDisabling = function()
{
if(oIPv6BasedACLPaging.urlCache.length==1)
{
this.pgTkn.AlterButtonBackNextTransDisabling("btnBack", true, "");
this.pgTkn.setTokenAttribute("btnBack","title","11014");
}
if(Page.dataXml.selectNodes("//ACLRuleList/ACLRuleEntry").length<oIPv6BasedACLPaging.pageSize)
{
this.pgTkn.AlterButtonBackNextTransDisabling("btnNext", true, "");
this.pgTkn.setTokenAttribute("btnNext","title","11015");
}
else
{
var id=this.groupTable.xmlData.selectSingleNode("//tr[position()="+oIPv6BasedACLPaging.pageSize+"]").getAttribute("ID");
document.getElementById(id).style.display="none";
document.getElementById(id).getElementsByTagName("input")[0].disabled=true;
}
}
this.openDialog = function(url)
{
_top.currIpv6AceName = this.acl;
OpenModalDialog(url);
}
this.LocalizeTableData = function()
{
Page.localize();
RT.localize("oIPv6BasedACL", "span_3_");
RT.localize("oIPv6BasedACL", "span_4_");
RT.localize("oIPv6BasedACL", "span_23_");
RT.localize("oIPv6BasedACL", "span_24_");
RT.localize("oIPv6BasedACL", "span_29_");
}
this.dispose = function()
{
this.pgTkn.destroy();
IPv6BasedACL.ACLName = "";
}
this.update_get = function()
{
var rowset = this.xmlData.selectNodes("//tr[@BIND and contains(@ID,'r')]");
var srcPortType,dstPortType,srcIPAddressType,dstIPAddressType,ToSType,portRangeStart,portRangeEnd;
var TCPFlagsEnable;
var TCPFlagsArr = new Array(6);
var contextnodeSrcPort,contextnodeDstPort,contextnodeSrcIPAddress,contextnodeDstIPAddress,contextnodeDSCP,contextNodeIPPrec;
var contextnodeFlags;
var targetCell, row_id, html_row;
for(var i=0;i<rowset.length;i++)
{
row_id = rowset[i].getAttribute("ID");
html_row = document.getElementById(row_id);
srcPortType = rowset[i].selectSingleNode(".//*[@BIND='IPv6Parameters/Source/sourcePortType']").getAttribute("VALUE");
dstPortType = rowset[i].selectSingleNode(".//*[@BIND='IPv6Parameters/Destination/destinationPortType']").getAttribute("VALUE");
srcIPAddressType = rowset[i].selectSingleNode(".//*[@BIND='IPv6Parameters/Source/sourceAddressType']").getAttribute("VALUE");
dstIPAddressType = rowset[i].selectSingleNode(".//*[@BIND='IPv6Parameters/Destination/destinationAddressType']").getAttribute("VALUE");
ToSType = rowset[i].selectSingleNode(".//*[@BIND='IPv6Parameters/ToSType']").getAttribute("VALUE");
TCPFlagsEnable = rowset[i].selectSingleNode(".//*[@BIND='IPv6Parameters/TCPFlagsEnabled']").getAttribute("VALUE");
TCPFlagsArr[0] = rowset[i].selectSingleNode(".//*[@BIND='IPv6Parameters/TCPFlags/urg']").getAttribute("VALUE");
TCPFlagsArr[1] = rowset[i].selectSingleNode(".//*[@BIND='IPv6Parameters/TCPFlags/ack']").getAttribute("VALUE");
TCPFlagsArr[2] = rowset[i].selectSingleNode(".//*[@BIND='IPv6Parameters/TCPFlags/psh']").getAttribute("VALUE");
TCPFlagsArr[3] = rowset[i].selectSingleNode(".//*[@BIND='IPv6Parameters/TCPFlags/rst']").getAttribute("VALUE");
TCPFlagsArr[4] = rowset[i].selectSingleNode(".//*[@BIND='IPv6Parameters/TCPFlags/syn']").getAttribute("VALUE");
TCPFlagsArr[5] = rowset[i].selectSingleNode(".//*[@BIND='IPv6Parameters/TCPFlags/fin']").getAttribute("VALUE");
contextnodeSrcPort = rowset[i].selectSingleNode(".//*[@BIND='IPv6Parameters/Source/sourcePort']");
contextnodeDstPort = rowset[i].selectSingleNode(".//*[@BIND='IPv6Parameters/Destination/destinationPort']");
contextnodeSrcIPAddress = rowset[i].selectSingleNode(".//*[@BIND='IPv6Parameters/Source/sourceIPv6Address']");
contextnodeDstIPAddress = rowset[i].selectSingleNode(".//*[@BIND='IPv6Parameters/Destination/destinationIPv6Address']");
contextnodeDSCP = rowset[i].selectSingleNode(".//*[@ID='DSCP']");
contextnodeIPPrec = rowset[i].selectSingleNode(".//*[@ID='IPPrec']");
contextnodeFlags = rowset[i].selectSingleNode(".//*[@ID='TCPFlags']");
if(srcPortType==1)
{
targetCell = html_row.getElementsByTagName("td")[11];
targetCell.id = "lblSrcPortRpt_"+i;
this.pgTkn.setTokenWithError(targetCell.id, "3080048");
}
else if(srcPortType==4)
{
portRangeStart = rowset[i].selectSingleNode(".//*[@BIND='IPv6Parameters/Source/sourcePortStart']").getAttribute("VALUE");
portRangeEnd = rowset[i].selectSingleNode(".//*[@BIND='IPv6Parameters/Source/sourcePortEnd']").getAttribute("VALUE");
targetCell = html_row.getElementsByTagName("td")[11];
targetCell.id = "lblSrcPortRpt_"+i;
this.pgTkn.setTokenWithError(targetCell.id, "3080047", [[TKN_NUMBER, portRangeStart.toString()],[TKN_NUMBER, portRangeEnd.toString()]]);
}
if(dstPortType==1)
{
targetCell = html_row.getElementsByTagName("td")[13];
targetCell.id = "lblDstPortRpt_"+i;
this.pgTkn.setTokenWithError(targetCell.id, "3080049");
}
else if(dstPortType == 4)
{
portRangeStart = rowset[i].selectSingleNode(".//*[@BIND='IPv6Parameters/Destination/destinationPortStart']").getAttribute("VALUE");
portRangeEnd = rowset[i].selectSingleNode(".//*[@BIND='IPv6Parameters/Destination/destinationPortEnd']").getAttribute("VALUE");
targetCell = html_row.getElementsByTagName("td")[13];
targetCell.id = "lblDstPortRpt_"+i;
this.pgTkn.setTokenWithError(targetCell.id, "3080047", [[TKN_NUMBER, portRangeStart.toString()],[TKN_NUMBER, portRangeEnd.toString()]]);
}
if(srcIPAddressType==1)
{
targetCell = html_row.getElementsByTagName("td")[5];
targetCell.id = "lblSrcAddrRpt_"+i;
this.pgTkn.setTokenWithError(targetCell.id, "3080050");
}
if(dstIPAddressType==1)
{
targetCell = html_row.getElementsByTagName("td")[8];
targetCell.id = "lblDstAddrRpt_"+i;
this.pgTkn.setTokenWithError(targetCell.id, "3080051");
}
if(ToSType==1 || ToSType==3)
{
targetCell = html_row.getElementsByTagName("td")[23];
targetCell.innerHTML = "";
}
if(ToSType==1 || ToSType==2)
{
targetCell = html_row.getElementsByTagName("td")[24];
targetCell.innerHTML = "";
}
if(TCPFlagsEnable==1)
{
targetCell = html_row.getElementsByTagName("td")[15];
targetCell.innerHTML = this.buildFlagsString(TCPFlagsArr);
}
}
}
this.buildFlagsString = function(TCPFlagsArr)
{
var retString = "";
for(var i=0;i<TCPFlagsArr.length;i++)
{
if(TCPFlagsArr[i]==1)
retString += "x";
if(TCPFlagsArr[i]==2)
retString += "1";
if(TCPFlagsArr[i]==3)
retString += "0";
}
return retString;
};
this.goToACLScreen = function()
{
openLink('2380~2780');
}
this.adjustStringToFilterLocal = function(theString)
{
var result="";
for (i=0;(i<theString.length);i++)
{
if ((theString.charAt(i)!='}')&&(theString.charAt(i)!='"')&&(theString.charAt(i)!='\'')&&(theString.charAt(i)!='\\'))
{
if (theString.charAt(i)=='#') result+="%23";
else if (theString.charAt(i)=='%') result+="%25";
else if (theString.charAt(i)=='?') result+="%3F";
else if (theString.charAt(i)==';') result+="%3B";
else if (theString.charAt(i)=='&') result+="%26";
else if (theString.charAt(i)=='+') result+="%2B";
else if (theString.charAt(i)=='^') result+="%5E";
else if (theString.charAt(i)=='{') result+="%7B";
else if (theString.charAt(i)=='(') result+="%28";
else if (theString.charAt(i)==')') result+="%29";
else result+=encodeURIComponent(theString.charAt(i));
}
else result+='\\'+theString.charAt(i);
}
return result;
}
this.buildIPv6BasedAclUrl = function()
{
var convertedaclname = this.adjustStringToFilterLocal(document.getElementById("cmbACL").value);
this.acl=document.getElementById("cmbACL").value;
IPv6BasedACL.ACLName = this.acl;
oIPv6BasedACLPaging.urlCache.length=0;
oIPv6BasedACLPaging.createUrl();
oIPv6BasedACLPaging.scope.url=oIPv6BasedACLPaging.urlCache[oIPv6BasedACLPaging.urlCache.length-1];
oIPv6BasedACLPaging.firstEntryInPage = 1;
oIPv6BasedACLPaging.scope.get(oIPv6BasedACLPaging.scope.url);
};
this.initIpv6BasedAclUrl = function()
{
if(_top.currIpv6AceName != "")
{
selectOptionByValue(document.getElementById("cmbACL"), _top.currIpv6AceName);
_top.currIpv6AceName = "";
}
this.buildIPv6BasedAclUrl();
}
this.deleteRule = function()
{
if(RT.deleteEntry())
{
HideSelectedRows("chkDel");
RT.save();
this.cleanDeleteXML();
_top.currIpv6AceName = IPv6BasedACL.ACLName;
oIPv6BasedACLPaging.urlCache.length=0;
oIPv6BasedACLPaging.createUrl();
oIPv6BasedACLPaging.scope.url=oIPv6BasedACLPaging.urlCache[oIPv6BasedACLPaging.urlCache.length-1];
oIPv6BasedACLPaging.firstEntryInPage = 1;
RT.send(oIPv6BasedACLPaging.scope.url);
}
};
this.cleanDeleteXML = function()
{
var currTagName;
var delNodes = Page.dataXml_delete.selectNodes("//*[@set='delete']");
for(var i = 0; i < delNodes.length; i++)
{
currTagName = delNodes[i].tagName;
if(currTagName != "DeviceConfiguration" && currTagName != "ACLRuleList" && currTagName != "ACLRuleEntry" && currTagName != "ACLName" && currTagName != "rulePriority")
delNodes[i].removeAttribute("set");
}
}
this.addRule = function()
{
if(document.getElementById("cmbACL").options.length==0)
{
alert("Rule can not be added since there is no ACL.");
return;
}
RT.OpenPopUp(900,620,'Add_Rule','oIPv6BasedACL',false,false);
}
this.checkACLs = function(PageLoaded)
{
var selAcl = getElement("cmbACL");
if(selAcl.options.length == 0)
{
selAcl.disabled=true;
AlterButtonDisabling("btnGo",true,"");
this.pgTkn.setTokenAttribute("btnGo","title","3080052");
AlterButtonDisabling("btnAdd",true,"");
this.pgTkn.setTokenAttribute("btnAdd","title","3080052");
}
else
{
if (PageLoaded)
this.initIpv6BasedAclUrl();
}
};
this.deleteACL =function()
{
var cmbACL=getElement("cmbACL");
if(cmbACL.options.length==0)
{
alert("There are no ACLs to delete");
return false;
}
var deletedACLName=cmbACL.options[cmbACL.selectedIndex].text;
var index=this.findDeletedIndex(deletedACLName);
this.buildDeleteXml(index)
var contextnode = Page.dataXml_delete.selectNodes ("//ACLList/ACLEntry")[index]
Page.setAlteredDataNodes(contextnode,ACTION_DELETE)
if(!Page.save())return false;
Page.send();
};
this.buildDeleteXml = function(index)
{
var node_from,node_to,section_node;
if(Page.dataXml_delete==null )
Page.dataXml_delete = IXML.getDomDocument(null,DATAROOT);
if(Page.dataXml_delete.selectSingleNode("//ACLList")==null)
{
section_node = Page.dataXml.selectSingleNode("//ACLList");
IXML.appendChild(section_node,Page.dataXml_delete.selectSingleNode("//" + DATAROOT))
}
node_from = Page.dataXml.selectNodes("//ACLList/ACLEntry")[index];
node_to = Page.dataXml_delete.selectNodes("//ACLList/ACLEntry")[index];
IXML.copyChildNodes(node_from,node_to);
}
this.findDeletedIndex=function(name)
{
var nodes=Page.dataXml.selectNodes("//ACLList/ACLEntry/ACLName");
for(var i=0;i<nodes.length;i++)
{
if(IXML.getText(nodes[i])==name)
return i;
}
return -1;
}
};
IPv6BasedACL.ACLName = "";
var oIPv6BasedACL
IPv6BasedACL.create=function(id)
{
oIPv6BasedACL= new IPv6BasedACL(Page.findNodeByUniqID(id));
if(oIPv6BasedACL.masterNode.attributes.getNamedItem("PAGING_ID")){
if (oIPv6BasedACLPaging && top.savePagingObj) {
oIPv6BasedACLPaging.scope=oIPv6BasedACL;
oIPv6BasedACL.url=oIPv6BasedACLPaging.urlCache[oIPv6BasedACLPaging.urlCache.length-1]
oIPv6BasedACL.get(oIPv6BasedACL.url);
}
else {
oIPv6BasedACLPaging = new IPv6BasedACLPaging(oIPv6BasedACL.masterNode.getAttribute("PAGING_ID"),oIPv6BasedACL);
oIPv6BasedACLPaging.init();
oIPv6BasedACLPaging.getPrev();
}
top.savePagingObj=false;
};
Page.subscribe('oIPv6BasedACL','RT');
Page.subscribe('oIPv6BasedACLPaging');
oIPv6BasedACL.initLocalization();
};
IPv6BasedACL.storeACLName = function()
{
IPv6BasedACL.ACLName = getElement("cmbACL").options[getElement("cmbACL").selectedIndex].value;
}
IPv6BasedACL.displayACLName = function()
{
if(IPv6BasedACL.ACLName != "")
selectOptionByValue(getElement("cmbACL"),IPv6BasedACL.ACLName);
}
IPv6BasedACL.getACLName = function()
{
}
IPv6BasedACL.complete_get= function (responseText,responseXML)
{
if(responseText!="")
{
var _responseText = responseText.trim()
if(_responseText.indexOf("<?xml")!=0)
{
var xml_pos=_responseText.indexOf("<?xml");
if(xml_pos==-1)
{
var str = _responseText.toLowerCase();
if(str.indexOf("authentication")!=-1 && str.indexOf("<html"))
{
if(opener)
{
opener.top.location.href=PageManager.AUTHENTICATION_PATH;
window.close();
}
else
top.location.href=PageManager.AUTHENTICATION_PATH;
return;
}
}
_responseText=_responseText.substr(xml_pos);
}
var xml = IXML.getDomDocument();
xml = (new DOMParser()).parseFromString(_responseText, "text/xml");
if(xml.childNodes.length==0)return;
if(!Page.checkValidResponse(xml))
{
return;
}
var acl=document.getElementById("cmbACL").value;
if(_top.currIpv6AceName != "")
{
acl = _top.currIpv6AceName;
_top.currIpv6AceName = "";
}
RT.get("wcd?{ACLRuleList&filter=(ACLName='"+acl+"')}");
}
}
var oIPv6BasedACLPaging;
Class(IPv6BasedACLPaging).Extends(PrevNextPaging);
function IPv6BasedACLPaging(){
this.konstructor=function(id,scope){
this.superclass(id,scope);
};
this.getNext=function(){
if(this.scope.xmlData && this.scope.cntRows && this.scope.cntRows >=this.pageSize){
var aclName=this.scope.xmlData.selectSingleNode("//tr[position()="+this.pageSize+"]").selectSingleNode(".//*[@BIND='ACLName']").getAttribute("VALUE");
var rulePriority=this.scope.xmlData.selectSingleNode("//tr[position()="+this.pageSize+"]").selectSingleNode(".//*[@BIND='rulePriority']").getAttribute("VALUE");
this.createUrl(aclName.toString(),rulePriority.toString());
this.scope.url=this.urlCache[this.urlCache.length-1];
this.scope.get(this.scope.url);
}
};
this.getPrev=function(){
if(this.urlCache.length>1){
this.urlCache.pop();
this.scope.url=this.urlCache[this.urlCache.length-1];
this.firstEntryInPage-=parseInt(top.numberOfEntriesPerPage)
}else{
this.scope.url=this.urlCache[0];
}
this.scope.get(this.scope.url);
};
this.createUrl=function(aclName,rulePriority){
var url="";
var CurACLName =oIPv6BasedACL.adjustStringToFilterLocal(document.getElementById("cmbACL").value);
if(rulePriority=="" || rulePriority=='undefined'|| rulePriority==null )
{
url = "wcd?{ACLRuleList&entryCount=en&Count=" + this.pageSize + "&filter=(ACLName='"+CurACLName+"') }{ACLList&filter=(ACLType=3)}";
}
else
{
url = this.urlTemplate.replace("#rulePriority#",rulePriority).replace("#COUNT#",this.pageSize).replace("#ACLName#",CurACLName).replace("#firstACLName#",CurACLName);
this.firstEntryInPage=((this.urlCache.length)*(this.pageSize-1))+1;
}
if (this.scope.total==0)
{
this.firstEntryInPage=0;
}
this.urlCache.push(url);
};
};
