<?xml version="1.0" encoding="UTF-8" ?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
    <xsl:template name="main">
        <xsl:choose>
            <xsl:when test="name()='screenSection'">
                <xsl:call-template name="CreateScreenSection"> </xsl:call-template>
            </xsl:when> 
        </xsl:choose>
        <xsl:choose>
            <xsl:when test="name()='bpButton'">
                <xsl:call-template name="CreateBpButton"> </xsl:call-template>
            </xsl:when> 
        </xsl:choose>
        <xsl:choose>
			<xsl:when test="name()='popupSection'">
                <xsl:call-template name="CreatePopupSection"> </xsl:call-template>
            </xsl:when> 
        </xsl:choose>
        <xsl:choose>
			<xsl:when test="name()='mainSection'">
                <xsl:call-template name="CreateMainSection"> </xsl:call-template>
            </xsl:when> 
        </xsl:choose>
    </xsl:template>
    
<xsl:template name="CreateScreenSection">
	<table WIDTH="95%" HEIGHT="100%" CELLPADDING="10" CELLSPACING="1" BORDER="0">
		<tr>
			<td> 
				<xsl:for-each select="./*">
					<xsl:call-template name="buildHTML"> </xsl:call-template>
				</xsl:for-each>      
			</td>
       </tr>           
	</table>
</xsl:template>

<xsl:template name="CreateMainSection">
	<table CELLPADDING="5" STYLE="border:1px solid #808080;">
		<tr>
			<td> 
				<xsl:for-each select="./*">
					<xsl:call-template name="buildHTML"> </xsl:call-template>
				</xsl:for-each>      
			</td>
       </tr>           
	</table>
</xsl:template>

<xsl:template name="CreatePopupSection">
	<table WIDTH="100%" HEIGHT="100%"><tr><td>
		<table WIDTH="100%" HEIGHT="100%" STYLE="">
			<tr oBGCOLOR="#5A88C6">
				<td ID="deviceName"></td>
				<td CLASS="PopCaption"><xsl:value-of select="@TITLE"/></td>
				<td>&#160;
					<!--img SRC="../images/Logo_PopUP.gif" height="62" width="184"/-->
				</td>
			</tr>
			<!--tr oBGCOLOR="#5A88C6">
				<td></td>
				<td CLASS="PopCaption" ALIGN="center"></td>
				<td></td>
			</tr>
			<tr>
				<td COLSPAN="2" ALIGN="left">
					<img SRC="../images/top_pop.gif"  HEIGHT="20" />
				</td>
				<td ALIGN="right">
					<img SRC="../images/top_pop_l.gif"  HEIGHT="20"/>
				</td>
			</tr-->
		</table>
	</td></tr>
	
	<tr><td>
		<table WIDTH="100%" HEIGHT="100%" BORDER="0">
			<tr>
				<td WIDTH="2%"></td>
				<td WIDTH="96%"> 
					<xsl:for-each select="./*">
						<xsl:call-template name="buildHTML"> </xsl:call-template>
					</xsl:for-each>      
				</td>
				<td WIDTH="2%"></td>
			</tr>           
		</table>
	</td></tr></table>
</xsl:template>

<xsl:template name="CreateBpButton">
	<xsl:element name="IMG">
		<xsl:if test="@CLASS">
			<xsl:attribute name="class">
				<xsl:value-of select="@CLASS"/>
			</xsl:attribute>
		</xsl:if>
		<xsl:if test="@STYLE">
			<xsl:attribute name="style">
				<xsl:value-of select="@STYLE"/>
			</xsl:attribute>
		</xsl:if>
		<xsl:if test="@ID">
			<xsl:attribute name="id">
				<xsl:value-of select="@ID"/>
			</xsl:attribute>
		</xsl:if>
		<xsl:if test="@NAME">
			<xsl:attribute name="name">
				<xsl:value-of select="@NAME"/>
			</xsl:attribute>
		</xsl:if>
		<xsl:attribute name="SRC">
			<xsl:if test="@TYPE='Apply'">../images/ciscoImages/proceed.gif</xsl:if>
			<xsl:if test="@TYPE='Delete'">../images/ciscoImages/delete.gif</xsl:if>
			<xsl:if test="@TYPE='Add'">../images/ciscoImages/add.gif</xsl:if>
			<xsl:if test="@TYPE='Modify'">../images/ciscoImages/edit.gif</xsl:if>
			<xsl:if test="@TYPE='Details'">../images/ciscoImages/details.gif</xsl:if>
			<xsl:if test="@TYPE='Add_ACL'">../images/ciscoImages/add_a.gif</xsl:if>
			<xsl:if test="@TYPE='Delete_ACL'">../images/ciscoImages/delete_a.gif</xsl:if>
			<xsl:if test="@TYPE='Add_ACL_Rule'">../images/ciscoImages/add_r.gif</xsl:if>
			<xsl:if test="@TYPE='Delete_ACL_Rule'">../images/ciscoImages/delete_r.gif</xsl:if>
		</xsl:attribute>
		<xsl:if test="@ONCLICK">
			<xsl:attribute name="ONCLICK">javascript:<xsl:value-of select="@ONCLICK"/></xsl:attribute>
		</xsl:if>
		<xsl:attribute name="title">
			<xsl:if test="@TYPE='Apply'">Proceed</xsl:if>
			<xsl:if test="@TYPE='Delete'">Delete</xsl:if>
			<xsl:if test="@TYPE='Add'">Add</xsl:if>
			<xsl:if test="@TYPE='Modify'">Modify</xsl:if>
			<xsl:if test="@TYPE='Details'">Details</xsl:if>
		</xsl:attribute>
		<xsl:attribute name="onmouseover">
			javascript:this.style.cursor="pointer";
		</xsl:attribute>
	</xsl:element>
</xsl:template>


     
</xsl:stylesheet>
