<?xml version="1.0" encoding="UTF-8" ?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
	<!--xsl:import href="CustomerTemplates.xsl"/-->
	<xsl:output method="xml" indent="yes" encoding="utf-8"/>
	<xsl:param name="moduleType"/>
	<xsl:param name="tableMode"/>
	<xsl:param name="defaultALIGN">left</xsl:param>
	<xsl:param name="defaultVALIGN">middle</xsl:param>
	<xsl:param name="defaultDIR">left</xsl:param>
	<xsl:template match="/">
		<!--zvi added height 100% to table and tr -->
		<table border="0" width="100%" dir="ltr" cellspacing="0" cellpadding="0">
			<tr valign="top">
				<td valign="top">
					<xsl:apply-templates/>
				</td>
			</tr>
		</table>
	</xsl:template>


	<xsl:template match="//*">

		<xsl:for-each select="./*">

			<xsl:call-template name="buildHTML"> </xsl:call-template>
		</xsl:for-each>

	</xsl:template>



	<xsl:template name="buildHTML">

		<xsl:choose>


			<xsl:when test="name()='MASTER'">
				<xsl:call-template name="CreateMaster"> </xsl:call-template>
			</xsl:when>
			<xsl:when test="name()='repeatedtable'">
				<xsl:call-template name="CreateRepeatedTable"> </xsl:call-template>
			</xsl:when>
			<!--xsl:when test="name()='repeatedrow'">
				<xsl:call-template name="CreateTableRow"> </xsl:call-template>
			</xsl:when-->
			<!--xsl:when test="name()='repeatedcell'">
				<xsl:call-template name="CreateHeader"> </xsl:call-template>
			</xsl:when-->
			<xsl:when test="name()='porttable'">
				<xsl:call-template name="CreateTable"> </xsl:call-template>
			</xsl:when>
			<xsl:when test="name()= 'fieldset'">
				<xsl:call-template name="CreateFieldset"> </xsl:call-template>
			</xsl:when>
			<xsl:when test="name()= 'legend'">
				<xsl:call-template name="CreateLegend"> </xsl:call-template>
			</xsl:when>

			<xsl:when test="name()= 'button'">
				<xsl:call-template name="CreateButton"> </xsl:call-template>
			</xsl:when>
			<xsl:when test="name()= 'image' or name()='img'">
				<xsl:call-template name="CreateImage"> </xsl:call-template>
			</xsl:when>
			<xsl:when test="name()= 'checkbox'">
				<xsl:call-template name="CreateCheckBox"> </xsl:call-template>
			</xsl:when>
			<xsl:when test="name()= 'option'">
				<xsl:call-template name="CreateOption"> </xsl:call-template>
			</xsl:when>
			<xsl:when test="name()= 'nobr'">
				<xsl:call-template name="CreateNOBR"> </xsl:call-template>
			</xsl:when>

			<xsl:when test="name()= 'u'">
				<xsl:call-template name="CreateUnderline"> </xsl:call-template>
			</xsl:when>

			<xsl:when test="name()='table'">
				<xsl:call-template name="CreateTable"> </xsl:call-template>
			</xsl:when>
			<xsl:when test="name()='innertable'">
				<xsl:call-template name="CreateTable"> </xsl:call-template>
			</xsl:when>
			<xsl:when test="name()='tr'">
				<xsl:call-template name="CreateTableRow"> </xsl:call-template>
			</xsl:when>
			<xsl:when test="name()='td'">
				<xsl:call-template name="CreateTableCell"> </xsl:call-template>
			</xsl:when>

			<xsl:when test="name()='thead'">
				<xsl:call-template name="CreateTableHeader"/>
			</xsl:when>

			<xsl:when test="name()='th'">
				<xsl:call-template name="CreateHeader"/>
			</xsl:when>

			<xsl:when test="name()='tfoot'">
				<xsl:call-template name="CreateFooter"/>
			</xsl:when>

			<xsl:when test="name()= 'div'">
				<xsl:call-template name="CreateDivision"> </xsl:call-template>
			</xsl:when>

			<xsl:when test="name()= 'combobox' or name()='select'">
				<xsl:call-template name="CreateComboBox"> </xsl:call-template>
			</xsl:when>
			<xsl:when test="name()= 'inputtext'">
				<xsl:call-template name="CreateInputText"> </xsl:call-template>
			</xsl:when>
			<xsl:when test="name()= 'hidden'">
				<xsl:call-template name="CreateHidden"> </xsl:call-template>
			</xsl:when>
			<xsl:when test="name()= 'hyperlink'">
				<xsl:call-template name="CreateLink"> </xsl:call-template>
			</xsl:when>
			<xsl:when test="name()= 'label'">
				<xsl:call-template name="CreateFrame"> </xsl:call-template>
			</xsl:when>
			<xsl:when test="name()= 'span'">
				<xsl:call-template name="CreateSpan"> </xsl:call-template>
			</xsl:when>
			<xsl:when test="name()= 'password'">
				<xsl:call-template name="CreatePassword"> </xsl:call-template>
			</xsl:when>

			<xsl:when test="name()= 'radio'">
				<xsl:call-template name="CreateRadio"> </xsl:call-template>
			</xsl:when>
			<xsl:when test="name()= 'hr'">
				<xsl:call-template name="CreateHR"> </xsl:call-template>
			</xsl:when>
			<xsl:when test="name()= 'br'">
				<xsl:call-template name="CreateBreak"> </xsl:call-template>
			</xsl:when>
			<xsl:when test="name()= 'innerframe' or name()='iframe'">
				<xsl:call-template name="CreateInnerFrame"> </xsl:call-template>
			</xsl:when>

			<xsl:when test="name()='pager'">
				<xsl:call-template name="CreatePagerHolder"> </xsl:call-template>
			</xsl:when>
			<xsl:when test="name()='bitmask'">
				<xsl:call-template name="CreateBitMaskHolder"/>
			</xsl:when>
			<xsl:when test="name()= 'file'">
				<xsl:call-template name="CreateInputFile"> </xsl:call-template>
			</xsl:when>

			<xsl:when test="name()= 'list'">
				<xsl:call-template name="CreateListHolder"> </xsl:call-template>
			</xsl:when>
			<!--xsl:when test="name()= 'range'">
				<xsl:call-template name="CreateInputText"> </xsl:call-template>
			</xsl:when-->
			<!--xsl:when test="name()= 'SystemInformation'">
				<xsl:call-template name="CreateTopLeftPanel"> </xsl:call-template>
			</xsl:when-->
			<xsl:otherwise>
				<xsl:call-template name="main"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="main"/>

	<xsl:template name="CreateTable">

		<table>
			<xsl:choose>
				<xsl:when test="@CELLPADDING[.!= '']">
					<xsl:attribute name="cellpadding">
						<xsl:value-of select="@CELLPADDING"/>
					</xsl:attribute>
				</xsl:when>
				<xsl:otherwise>
					<xsl:attribute name="cellpadding">0 </xsl:attribute>
				</xsl:otherwise>
			</xsl:choose>
			<xsl:choose>
				<xsl:when test="@CELLSPACING[.!= '']">
					<xsl:attribute name="cellspacing">
						<xsl:value-of select="@CELLSPACING"/>
					</xsl:attribute>
				</xsl:when>
				<xsl:otherwise>
					<xsl:attribute name="cellspacing">0 </xsl:attribute>
				</xsl:otherwise>
			</xsl:choose>

			<xsl:if test="@CLASS[.!= '']">
				<xsl:attribute name="class">
					<xsl:value-of select="@CLASS"/>
				</xsl:attribute>
			</xsl:if>
			<xsl:if test="@STYLE">
				<xsl:attribute name="style">
					<xsl:value-of select="@STYLE"/>
				</xsl:attribute>
			</xsl:if>


			<xsl:if test="@NAME[.!= '']">
				<xsl:attribute name="name">
					<xsl:value-of select="@NAME"/>
				</xsl:attribute>
			</xsl:if>
			<xsl:if test="@ID[.!= '']">
				<xsl:attribute name="id">
					<xsl:value-of select="@ID"/>
				</xsl:attribute>
			</xsl:if>
			<xsl:if test="@WIDTH">
				<xsl:attribute name="width">
					<xsl:value-of select="@WIDTH"/>
				</xsl:attribute>
			</xsl:if>
			<xsl:if test="@HEIGHT">
				<xsl:attribute name="height">
					<xsl:value-of select="@HEIGHT"/>
				</xsl:attribute>
			</xsl:if>
			<xsl:if test="@BGCOLOR[.!= '']">
				<xsl:attribute name="bgcolor">
					<xsl:value-of select="@BGCOLOR"/>
				</xsl:attribute>
			</xsl:if>

			<xsl:if test="@BORDER[.!= '']">
				<xsl:attribute name="border">
					<xsl:value-of select="@BORDER"/>
				</xsl:attribute>
			</xsl:if>
			<xsl:if test="@ALIGN">
				<xsl:attribute name="align">
					<xsl:value-of select="@ALIGN"/>
				</xsl:attribute>
			</xsl:if>

			<xsl:for-each select="./*">
				<xsl:call-template name="buildHTML"> </xsl:call-template>
			</xsl:for-each>

		</table>

	</xsl:template>

	<xsl:template name="CreateTableRow">
		<xsl:if test="boolean(@DELETED)=false">
			<tr>
				<xsl:if test="@ID">
					<xsl:attribute name="id">
						<xsl:value-of select="@ID"/>
					</xsl:attribute>
				</xsl:if>

				<xsl:if test="@CLASS">
					<xsl:attribute name="class">
						<xsl:value-of select="@CLASS"/>
					</xsl:attribute>
				</xsl:if>
				<xsl:if test="@STYLE">
					<xsl:attribute name="style">
						<xsl:value-of select="@STYLE"/>
					</xsl:attribute>
				</xsl:if>

				<xsl:if test="@HEIGHT">
					<xsl:attribute name="height">
						<xsl:value-of select="@HEIGHT"/>
					</xsl:attribute>
				</xsl:if>

				<xsl:if test="@ONMOUSEOVER">
					<xsl:attribute name="onmouseover"><xsl:value-of select="@ONMOUSEOVER"
					/>;</xsl:attribute>
				</xsl:if>
				<xsl:if test="@ONMOUSEOUT">
					<xsl:attribute name="onmouseout"><xsl:value-of select="@ONMOUSEOUT"
					/>;</xsl:attribute>
				</xsl:if>
				<xsl:if test="@ONCLICK">
					<xsl:attribute name="onclick"><xsl:value-of select="@ONCLICK"/>;</xsl:attribute>
				</xsl:if>


				<xsl:for-each select="./*">
					<xsl:call-template name="buildHTML"> </xsl:call-template>
				</xsl:for-each>

			</tr>
		</xsl:if>
	</xsl:template>

	<xsl:template name="CreateTableCell">

		<td class="{@CLASS}">

			<xsl:if test="@ID">
				<xsl:attribute name="id">
					<xsl:value-of select="@ID"/>
				</xsl:attribute>
			</xsl:if>
			<xsl:if test="@WIDTH">
				<xsl:attribute name="width">
					<xsl:value-of select="@WIDTH"/>
				</xsl:attribute>
			</xsl:if>
			<xsl:if test="@HEIGHT">
				<xsl:attribute name="height">
					<xsl:value-of select="@HEIGHT"/>
				</xsl:attribute>
			</xsl:if>


			<xsl:if test="@COLSPAN">
				<xsl:attribute name="colspan">
					<xsl:value-of select="@COLSPAN"/>
				</xsl:attribute>
			</xsl:if>
			<xsl:if test="@ROWSPAN">
				<xsl:attribute name="rowspan">
					<xsl:value-of select="@ROWSPAN"/>
				</xsl:attribute>
			</xsl:if>

			<xsl:if test="@STYLE">
				<xsl:attribute name="style">
					<xsl:value-of select="@STYLE"/>
				</xsl:attribute>
			</xsl:if>

			<xsl:choose>
				<xsl:when test="@ALIGN">
					<xsl:attribute name="align">
						<xsl:value-of select="@ALIGN"/>
					</xsl:attribute>
				</xsl:when>
				<xsl:otherwise>
					<xsl:attribute name="align">
						<xsl:value-of select="$defaultALIGN"/>
					</xsl:attribute>
				</xsl:otherwise>
			</xsl:choose>

			<xsl:choose>
				<xsl:when test="@VALIGN">
					<xsl:attribute name="valign">
						<xsl:value-of select="@VALIGN"/>
					</xsl:attribute>
				</xsl:when>
				<xsl:otherwise>
					<xsl:attribute name="valign">
						<xsl:value-of select="$defaultVALIGN"/>
					</xsl:attribute>
				</xsl:otherwise>
			</xsl:choose>

			<xsl:if test="@ONMOUSEMOVE">
				<xsl:attribute name="onmousemove"><xsl:value-of select="@ONMOUSEMOVE"
				/>;</xsl:attribute>
			</xsl:if>
			<xsl:if test="@ONMOUSEOUT">
				<xsl:attribute name="onmouseout"><xsl:value-of select="@ONMOUSEOUT"
				/>;</xsl:attribute>
			</xsl:if>
			<xsl:if test="@ONCLICK">
				<xsl:attribute name="onclick"><xsl:value-of select="@ONCLICK"/>;</xsl:attribute>
			</xsl:if>

			<xsl:variable name="pathcell">
				<xsl:choose>
					<xsl:when test="@BIND">
						<xsl:value-of select="@BIND"/>
					</xsl:when>
					<xsl:otherwise> 0 </xsl:otherwise>
				</xsl:choose>
			</xsl:variable>
			<xsl:variable name="datapath">
				<xsl:value-of select="substring-before($pathcell,'/')"/>
			</xsl:variable>
			<xsl:variable name="datanode" select="//*[name()=$datapath]"/>


			<xsl:choose>
				<xsl:when test="$pathcell != 0 and $tableMode!=1">
					<xsl:choose>
						<xsl:when test="contains(substring-after($pathcell,'/'),'/')">
							<xsl:for-each select="$datanode/descendant::*">
								<xsl:call-template name="FindData">
									<xsl:with-param name="nodename">
										<xsl:value-of
											select="substring-before(substring-after($pathcell,'/'),'/')"
										/>
									</xsl:with-param>
									<xsl:with-param name="tail">
										<xsl:value-of
											select="substring-after(substring-after($pathcell,'/'),'/')"
										/>
									</xsl:with-param>
								</xsl:call-template>
							</xsl:for-each>
						</xsl:when>
						<xsl:otherwise>
							<xsl:value-of select="//*[name()=substring-after($pathcell,'/')]/text()"
								disable-output-escaping="yes"/>
						</xsl:otherwise>
					</xsl:choose>
				</xsl:when>
				<xsl:otherwise>
					<xsl:choose>
						<xsl:when test="@ALIAS">
							<xsl:value-of select="@ALIAS"/>
						</xsl:when>
						<xsl:otherwise>
							<xsl:value-of select="./text()"/>
						</xsl:otherwise>
					</xsl:choose>
				</xsl:otherwise>
			</xsl:choose>

			<xsl:for-each select="./*">
				<xsl:call-template name="buildHTML"> </xsl:call-template>
			</xsl:for-each>
		</td>


	</xsl:template>

	<xsl:template name="CreateTableHeader">


		<thead>

			<xsl:for-each select="./*">
				<xsl:call-template name="buildHTML"> </xsl:call-template>
			</xsl:for-each>
		</thead>
	</xsl:template>

	<xsl:template name="CreateFooter">
		<tfoot>
			<xsl:for-each select="./*">
				<xsl:call-template name="buildHTML"> </xsl:call-template>
			</xsl:for-each>
		</tfoot>
	</xsl:template>

	<xsl:template name="CreateHeader">
		<th>

			<xsl:if test="CLASS">
				<xsl:attribute name="class">
					<xsl:value-of select="@CLASS"/>
				</xsl:attribute>
			</xsl:if>
			<xsl:if test="@STYLE">
				<xsl:attribute name="style">
					<xsl:value-of select="@STYLE"/>
				</xsl:attribute>
			</xsl:if>
			<xsl:if test="@ID">
				<xsl:attribute name="id">
					<xsl:value-of select="@ID"/>
				</xsl:attribute>
			</xsl:if>

			<xsl:choose>
				<xsl:when test="@ALIGN">
					<xsl:attribute name="align">
						<xsl:value-of select="@ALIGN"/>
					</xsl:attribute>
				</xsl:when>
				<xsl:otherwise>
					<xsl:attribute name="align">
						<xsl:value-of select="$defaultALIGN"/>
					</xsl:attribute>
				</xsl:otherwise>
			</xsl:choose>

			<xsl:if test="@VALIGN">
				<xsl:attribute name="valign">
					<xsl:value-of select="@VALIGN"/>
				</xsl:attribute>
			</xsl:if>
			<xsl:if test="@WIDTH">
				<xsl:attribute name="width">
					<xsl:value-of select="@WIDTH"/>
				</xsl:attribute>
			</xsl:if>
			<xsl:if test="@ROWSPAN">
				<xsl:attribute name="rowspan">
					<xsl:value-of select="@ROWSPAN"/>
				</xsl:attribute>
			</xsl:if>
			<xsl:if test="@COLSPAN">
				<xsl:attribute name="colspan">
					<xsl:value-of select="@COLSPAN"/>
				</xsl:attribute>
			</xsl:if>
			<xsl:choose>
				<xsl:when test="@ALIAS">
					<xsl:value-of select="@ALIAS"/>
				</xsl:when>
				<xsl:otherwise>
					<xsl:value-of select="./text()"/>
				</xsl:otherwise>
			</xsl:choose>
			<xsl:if test="@ONCLICK">
				<xsl:attribute name="onclick">
					<xsl:value-of select="@ONCLICK"/>
				</xsl:attribute>
			</xsl:if>
			<xsl:for-each select="./*">
				<xsl:call-template name="buildHTML"/>
			</xsl:for-each>

		</th>
	</xsl:template>

	<!--   *******repeatedtable templates ********** begin     -->
	<xsl:template name="CreateRepeatedTable">
		<xsl:if test="not(@BIND) or not(@OBJECT) or not(@ID)">
			<span style="display:none" name="DiagnoseSpan"> repeated table requirement violation:
				<br/> The attributes BIND, OBJECT and ID are mandatory </span>
		</xsl:if>
		<div>
			<xsl:variable name="tableID">
				<xsl:value-of select="@ID"/>
			</xsl:variable>
			<xsl:attribute name="id">
				<xsl:value-of select="concat('container',$tableID)"/>
			</xsl:attribute>
			<table class="{@CLASS}">
				<xsl:choose>
					<xsl:when test="@CELLPADDING">
						<xsl:attribute name="cellpadding">
							<xsl:value-of select="@CELLPADDING"/>
						</xsl:attribute>
					</xsl:when>
					<xsl:otherwise>
						<xsl:attribute name="cellpadding">0</xsl:attribute>
					</xsl:otherwise>
				</xsl:choose>
				<xsl:choose>
					<xsl:when test="@CELLSPACING">
						<xsl:attribute name="cellspacing">
							<xsl:value-of select="@CELLSPACING"/>
						</xsl:attribute>
					</xsl:when>
					<xsl:otherwise>
						<xsl:attribute name="cellspacing">
							<xsl:value-of select="@CELLSPACING"/>
						</xsl:attribute>
					</xsl:otherwise>
				</xsl:choose>
				<xsl:if test="@WIDTH">
					<xsl:attribute name="width">
						<xsl:value-of select="@WIDTH"/>
					</xsl:attribute>
				</xsl:if>
				<xsl:if test="@HEIGHT">
					<xsl:attribute name="height">
						<xsl:value-of select="@HEIGHT"/>
					</xsl:attribute>
				</xsl:if>
				<xsl:if test="@BORDER">
					<xsl:attribute name="border">
						<xsl:value-of select="@BORDER"/>
					</xsl:attribute>
				</xsl:if>
				<xsl:attribute name="id">
					<xsl:value-of select="@ID"/>
				</xsl:attribute>
				<xsl:variable name="coll">
					<xsl:value-of select="count(.//repeatedrow/repeatedcell)"/>
				</xsl:variable>
				<!--xsl:attribute name="colspan">
					<xsl:value-of select="$coll"/>
				</xsl:attribute-->

				<xsl:for-each select="./*">
					<xsl:call-template name="buildHTML"> </xsl:call-template>
				</xsl:for-each>



				<xsl:variable name="bind">
					<xsl:value-of select="@BIND"/>
				</xsl:variable>
				<xsl:variable name="api_name">
					<xsl:choose>
						<xsl:when test="contains($bind,'/')">
							<xsl:value-of select="substring-before($bind,'/')"/>
						</xsl:when>
						<xsl:otherwise>
							<xsl:value-of select="$bind"/>
						</xsl:otherwise>
					</xsl:choose>
				</xsl:variable>
				<xsl:variable name="xpathtable">
					<xsl:choose>
						<xsl:when test="contains($bind,'/')">
							<xsl:call-template name="FindDestNodeName">
								<xsl:with-param name="path">
									<xsl:value-of select="$bind"/>
								</xsl:with-param>
							</xsl:call-template>
						</xsl:when>
						<xsl:otherwise>
							<xsl:value-of select="$api_name"/>
						</xsl:otherwise>
					</xsl:choose>
				</xsl:variable>
				<xsl:variable name="xpathrow">
					<xsl:value-of select="./repeatedrow/@BIND"/>
				</xsl:variable>
				<xsl:variable name="row_onclick">
					<xsl:choose>
						<xsl:when test="./repeatedrow/@ONCLICK">
							<xsl:value-of select="./repeatedrow/@ONCLICK"/>
						</xsl:when>
						<xsl:otherwise>0</xsl:otherwise>
					</xsl:choose>
				</xsl:variable>
				<xsl:variable name="row_onmouseover">
					<xsl:choose>
						<xsl:when test="./repeatedrow/@ONMOUSEOVER">
							<xsl:value-of select="./repeatedrow/@ONMOUSEOVER"/>
						</xsl:when>
						<xsl:otherwise>0</xsl:otherwise>
					</xsl:choose>
				</xsl:variable>
				<xsl:variable name="row_onmouseout">
					<xsl:choose>
						<xsl:when test="./repeatedrow/@ONMOUSEOUT">
							<xsl:value-of select="./repeatedrow/@ONMOUSEOUT"/>
						</xsl:when>
						<xsl:otherwise>0</xsl:otherwise>
					</xsl:choose>
				</xsl:variable>
				<xsl:variable name="class">
					<xsl:choose>
						<xsl:when test="./repeatedrow/@CLASS">
							<xsl:value-of select="./repeatedrow/@CLASS"/>
						</xsl:when>
						<xsl:otherwise>0</xsl:otherwise>
					</xsl:choose>
				</xsl:variable>
				<xsl:variable name="class_odd">
					<xsl:choose>
						<xsl:when test="./repeatedrow/@CLASS_ODD">
							<xsl:value-of select="./repeatedrow/@CLASS_ODD"/>
						</xsl:when>
						<xsl:otherwise>0</xsl:otherwise>
					</xsl:choose>
				</xsl:variable>
				<xsl:choose>
					<xsl:when test="$api_name=$xpathtable">
						<xsl:for-each
							select="//*[name()=$xpathtable]/descendant::*[name()=$xpathrow]">
							<tr>
								<xsl:attribute name="id">r<xsl:value-of select="position()-1"
										/>_<xsl:value-of select="$tableID"/></xsl:attribute>
								<xsl:choose>
									<xsl:when test="$class_odd!=0">
										<xsl:choose>
											<xsl:when test="(position()-1) mod 2 !=0">
												<xsl:attribute name="class">
												<xsl:value-of select="$class_odd"/>
												</xsl:attribute>
											</xsl:when>
											<xsl:otherwise>
												<xsl:attribute name="class">
												<xsl:value-of select="$class"/>
												</xsl:attribute>
											</xsl:otherwise>
										</xsl:choose>
									</xsl:when>
									<xsl:otherwise>
										<xsl:attribute name="class">
											<xsl:value-of select="$class"/>
										</xsl:attribute>
									</xsl:otherwise>
								</xsl:choose>
								<xsl:if test="$row_onclick!=0">
									<xsl:attribute name="onclick">
										<xsl:value-of select="$row_onclick"/>
									</xsl:attribute>
								</xsl:if>
								<xsl:if test="$row_onmouseover!=0">
									<xsl:attribute name="onmouseover">
										<xsl:value-of select="$row_onmouseover"/>
									</xsl:attribute>
								</xsl:if>
								<xsl:if test="$row_onmouseout!=0">
									<xsl:attribute name="onmouseout">
										<xsl:value-of select="$row_onmouseout"/>
									</xsl:attribute>
								</xsl:if>
								<xsl:call-template name="CreateRepeatedTableCell">
									<xsl:with-param name="cntCells">
										<xsl:value-of select="$coll"/>
									</xsl:with-param>
									<xsl:with-param name="counter">1</xsl:with-param>
									<xsl:with-param name="tableName">
										<xsl:value-of select="$tableID"/>
									</xsl:with-param>
									<xsl:with-param name="rowPos">
										<xsl:value-of select="position()"/>
									</xsl:with-param>
								</xsl:call-template>
							</tr>
						</xsl:for-each>
					</xsl:when>
					<xsl:otherwise>
						<xsl:for-each
							select="//*[name()=$api_name]/descendant::*[name()=$xpathtable]/descendant::*[name()=$xpathrow]">
							<tr>
								<xsl:attribute name="id">r<xsl:value-of select="position()-1"
										/>_<xsl:value-of select="$tableID"/></xsl:attribute>
								<xsl:choose>
									<xsl:when test="$class_odd!=0">
										<xsl:choose>
											<xsl:when test="(position()-1) mod 2 !=0">
												<xsl:attribute name="class">
												<xsl:value-of select="$class_odd"/>
												</xsl:attribute>
											</xsl:when>
											<xsl:otherwise>
												<xsl:attribute name="class">
												<xsl:value-of select="$class"/>
												</xsl:attribute>
											</xsl:otherwise>
										</xsl:choose>
									</xsl:when>
									<xsl:otherwise>
										<xsl:attribute name="class">
											<xsl:value-of select="$class"/>
										</xsl:attribute>
									</xsl:otherwise>
								</xsl:choose>
								<xsl:if test="$row_onclick!=0">
									<xsl:attribute name="onclick">
										<xsl:value-of select="$row_onclick"/>
									</xsl:attribute>
								</xsl:if>
								<xsl:if test="$row_onmouseover!=0">
									<xsl:attribute name="onmouseover">
										<xsl:value-of select="$row_onmouseover"/>
									</xsl:attribute>
								</xsl:if>
								<xsl:if test="$row_onmouseout!=0">
									<xsl:attribute name="onmouseout">
										<xsl:value-of select="$row_onmouseout"/>
									</xsl:attribute>
								</xsl:if>
								<xsl:call-template name="CreateRepeatedTableCell">
									<xsl:with-param name="cntCells">
										<xsl:value-of select="$coll"/>
									</xsl:with-param>
									<xsl:with-param name="counter">1</xsl:with-param>
									<xsl:with-param name="tableName">
										<xsl:value-of select="$tableID"/>
									</xsl:with-param>
									<xsl:with-param name="rowPos">
										<xsl:value-of select="position()"/>
									</xsl:with-param>
								</xsl:call-template>
							</tr>
						</xsl:for-each>
					</xsl:otherwise>
				</xsl:choose>



				<!--/tbody-->

			</table>
		</div>
	</xsl:template>

	<xsl:template name="CreateRepeatedTableCell">
		<xsl:param name="cntCells"/>
		<xsl:param name="counter"/>
		<xsl:param name="tableName"/>
		<xsl:param name="rowPos"/>


		<xsl:if test="$counter &lt;= $cntCells">
			<xsl:variable name="pathcell">
				<xsl:value-of
					select="//*[@ID=$tableName]//repeatedrow/child::*[position()=$counter]/@BIND"/>
			</xsl:variable>
			<xsl:variable name="width">
				<xsl:value-of
					select="//*[@ID=$tableName]//repeatedrow/child::*[position()=$counter]/@WIDTH"/>
			</xsl:variable>
			<xsl:variable name="enum"
				select="//*[@ID=$tableName]//repeatedrow/child::*[position()=$counter]/@ENUM"/>
			<xsl:variable name="filter"
				select="//*[@ID=$tableName]//repeatedrow/child::*[position()=$counter]/@FILTER"/>
			<xsl:variable name="class"
				select="//*[@ID=$tableName]//repeatedrow/child::*[position()=$counter]/@CLASS"/>
			<xsl:variable name="style"
				select="//*[@ID=$tableName]//repeatedrow/child::*[position()=$counter]/@STYLE"/>
			<xsl:variable name="onclick"
				select="//*[@ID=$tableName]//repeatedrow/child::*[position()=$counter]/@ONCLICK"/>
			<xsl:variable name="ondblclick"
				select="//*[@ID=$tableName]//repeatedrow/child::*[position()=$counter]/@ONDBLCLICK"/>
			<xsl:variable name="onmouseover"
				select="//*[@ID=$tableName]//repeatedrow/child::*[position()=$counter]/@ONMOUSEOVER"/>
			<xsl:variable name="onmouseout"
				select="//*[@ID=$tableName]//repeatedrow/child::*[position()=$counter]/@ONMOUSEOUT"/>
			<xsl:variable name="onmousemove"
				select="//*[@ID=$tableName]//repeatedrow/child::*[position()=$counter]/@ONMOUSEMOVE"/>
			<xsl:variable name="isOuterSrc">
				<xsl:choose>
					<xsl:when
						test="boolean(//*[@ID=$tableName]//repeatedrow/child::*[position()=$counter]/@OUTER_BIND)"
						> true </xsl:when>
					<xsl:otherwise>false</xsl:otherwise>
				</xsl:choose>
			</xsl:variable>
			<xsl:variable name="datapath">
				<xsl:value-of select="substring-before($pathcell,'/')"/>
			</xsl:variable>
			<xsl:variable name="datanode" select="./descendant::*[name()=$datapath]"/>
			<xsl:variable name="innercontrol_datapath">
				<xsl:choose>
					<xsl:when
						test="//*[@ID=$tableName]//repeatedrow/child::*[position()=$counter]/*[position()=1 and @BIND]">
						<xsl:value-of
							select="//*[@ID=$tableName]//repeatedrow/child::*[position()=$counter]/*[position()=1]/@BIND"
						/>
					</xsl:when>
					<xsl:otherwise>0</xsl:otherwise>
				</xsl:choose>
			</xsl:variable>
			<xsl:variable name="innercontrol_enum">
				<xsl:choose>
					<xsl:when
						test="//*[@ID=$tableName]//repeatedrow/child::*[position()=$counter]/*[position()=1 and @BIND and @ENUM]">
						<xsl:value-of
							select="//*[@ID=$tableName]//repeatedrow/child::*[position()=$counter]/*[position()=1]/@ENUM"
						/>
					</xsl:when>
					<xsl:otherwise>0</xsl:otherwise>
				</xsl:choose>
			</xsl:variable>

			<td>



				<xsl:if test="$class">
					<xsl:attribute name="class">
						<xsl:value-of select="$class"/>
					</xsl:attribute>
				</xsl:if>
				<xsl:if test="$style">
					<xsl:attribute name="style">
						<xsl:value-of select="$style"/>
					</xsl:attribute>
				</xsl:if>
				<xsl:if test="$onclick">
					<xsl:attribute name="onclick">
						<xsl:value-of select="$onclick"/>
					</xsl:attribute>
				</xsl:if>
				<xsl:if test="$ondblclick">
					<xsl:attribute name="ondblclick">
						<xsl:value-of select="$ondblclick"/>
					</xsl:attribute>
				</xsl:if>
				<xsl:if test="$onmouseover">
					<xsl:attribute name="onmouseover">
						<xsl:value-of select="$onmouseover"/>
					</xsl:attribute>
				</xsl:if>
				<xsl:if test="$onmouseout">
					<xsl:attribute name="onmouseout">
						<xsl:value-of select="$onmouseout"/>
					</xsl:attribute>
				</xsl:if>
				<xsl:if test="$onmousemove">
					<xsl:attribute name="onmousemove">
						<xsl:value-of select="$onmousemove"/>
					</xsl:attribute>
				</xsl:if>

				<xsl:if test="$width!=''">
					<xsl:attribute name="width">
						<xsl:value-of select="$width"/>
					</xsl:attribute>
				</xsl:if>
				<xsl:variable name="celldata">
					<xsl:choose>
						<xsl:when test="contains($pathcell,'/')">
							<xsl:choose>
								<xsl:when
									test="boolean(//*[@ID=$tableName]//repeatedrow/child::*[position()=$counter]/@OUTER_BIND)">

									<xsl:call-template name="FindData">
										<xsl:with-param name="nodename">
											<xsl:value-of select="substring-before($pathcell,'/')"/>
										</xsl:with-param>
										<xsl:with-param name="tail">
											<xsl:value-of select="substring-after($pathcell,'/')"/>
										</xsl:with-param>
										<xsl:with-param name="outerdata">
											<xsl:value-of select="$isOuterSrc"/>
										</xsl:with-param>
										<xsl:with-param name="rowPos">
											<xsl:value-of select="$rowPos"/>
										</xsl:with-param>
										<xsl:with-param name="posCell">
											<xsl:value-of select="$counter"/>
										</xsl:with-param>
										<xsl:with-param name="filter">
											<xsl:value-of select="$filter"/>
										</xsl:with-param>
									</xsl:call-template>
								</xsl:when>

								<xsl:when
									test="boolean(//*[@ID=$tableName]//repeatedrow/child::*[position()=$counter and @TYPE='bitmask'])">

									<xsl:call-template name="GetBitMaskData">

										<xsl:with-param name="tail">
											<xsl:value-of select="substring-after($pathcell,'/')"/>
										</xsl:with-param>
										<xsl:with-param name="tableName">
											<xsl:value-of select="$tableName"/>
										</xsl:with-param>
										<xsl:with-param name="posCell">
											<xsl:value-of select="$counter"/>
										</xsl:with-param>

									</xsl:call-template>
								</xsl:when>
								<xsl:otherwise>

									<xsl:for-each select="$datanode">
										<xsl:call-template name="FindData">
											<xsl:with-param name="nodename">
												<xsl:value-of
												select="substring-before($pathcell,'/')"/>
											</xsl:with-param>
											<xsl:with-param name="tail">
												<xsl:value-of
												select="substring-after($pathcell,'/')"/>
											</xsl:with-param>
											<xsl:with-param name="outerdata">false</xsl:with-param>
											<xsl:with-param name="rowPos"/>
											<xsl:with-param name="posCell"/>
											<xsl:with-param name="filter">
												<xsl:value-of select="$filter"/>
											</xsl:with-param>
										</xsl:call-template>
									</xsl:for-each>
								</xsl:otherwise>
							</xsl:choose>
						</xsl:when>
						<xsl:otherwise>
							<xsl:variable name="delim">
								<xsl:value-of
									select="//*[@ID=$tableName]//repeatedrow/child::*[position()=$counter and @TYPE='bitmask']/@DELIMETER"
								/>
							</xsl:variable>

							<xsl:choose>
								<xsl:when test="$innercontrol_datapath!=0">

									<xsl:choose>
										<xsl:when test="contains($innercontrol_datapath,'/')">
											<xsl:for-each
												select="./descendant::*[name()=substring-before($innercontrol_datapath,'/')]">
												<xsl:call-template name="FindData">
												<xsl:with-param name="nodename">
												<xsl:value-of
												select="substring-before($innercontrol_datapath,'/')"
												/>
												</xsl:with-param>
												<xsl:with-param name="tail">
												<xsl:value-of
												select="substring-after($innercontrol_datapath,'/')"
												/>
												</xsl:with-param>
												<xsl:with-param name="outerdata">false</xsl:with-param>
												<xsl:with-param name="rowPos"/>
												<xsl:with-param name="posCell"/>
												<xsl:with-param name="filter">
												<xsl:value-of
												select="//*[@ID=$tableName]//repeatedrow/child::*[position()=$counter]/*[position()=1]/@FILTER"
												/>
												</xsl:with-param>
												</xsl:call-template>
											</xsl:for-each>
										</xsl:when>
										<xsl:otherwise>

											<xsl:value-of
												select="./*[name()=$innercontrol_datapath]/text()"
												disable-output-escaping="yes"/>
										</xsl:otherwise>
									</xsl:choose>


								</xsl:when>
								<xsl:when
									test="boolean(//*[@ID=$tableName]//repeatedrow/child::*[position()=$counter and @BIND and  @TYPE='bitmask'])">
									<xsl:call-template name="TranslateBitMask">
										<xsl:with-param name="bitmask">
											<xsl:value-of select="./*[name()=$pathcell]/text()"/>
										</xsl:with-param>
										<xsl:with-param name="bmsk_id">
											<xsl:value-of
												select="//*[@ID=$tableName]//repeatedrow/child::*[position()=$counter and @TYPE='bitmask']/@BMSK_ID"
											/>
										</xsl:with-param>
										<xsl:with-param name="tablename">
											<xsl:value-of select="$tableName"/>
										</xsl:with-param>
										<xsl:with-param name="posCell">
											<xsl:value-of select="$counter"/>
										</xsl:with-param>
										<xsl:with-param name="pos">0</xsl:with-param>
										<xsl:with-param name="delim">
											<xsl:value-of select="$delim"/>
										</xsl:with-param>
									</xsl:call-template>
								</xsl:when>
								<xsl:otherwise>
									<xsl:value-of select="./*[name()=$pathcell]/text()"
										disable-output-escaping="yes"/>
								</xsl:otherwise>
							</xsl:choose>

						</xsl:otherwise>
					</xsl:choose>
				</xsl:variable>


				<xsl:variable name="enumNodeName">
					<xsl:call-template name="FindDestNodeName">
						<xsl:with-param name="path">
							<xsl:value-of select="$pathcell"/>
						</xsl:with-param>
					</xsl:call-template>
				</xsl:variable>

				<xsl:variable name="enumData">
					<xsl:choose>
						<xsl:when
							test="//ENUM/child::*[name()=$enumNodeName]/child::*[@VALUE[.=$celldata]]">
							<xsl:value-of
								select="//ENUM/child::*[name()=$enumNodeName]/child::*[@VALUE[.=$celldata]]/text()"
								disable-output-escaping="yes"/>
						</xsl:when>
						<xsl:otherwise>
							<xsl:value-of select="$celldata" disable-output-escaping="yes"/>
						</xsl:otherwise>
					</xsl:choose>

				</xsl:variable>

				<xsl:choose>
					<xsl:when
						test="//*[@ID=$tableName]//repeatedrow/child::*[position()=$counter]/@NOBR">
						<nobr>
							<xsl:choose>
								<xsl:when test="$enum">
									<xsl:value-of select="$enumData"/>
								</xsl:when>
								<xsl:otherwise>
									<xsl:value-of select="$celldata" disable-output-escaping="yes"/>
								</xsl:otherwise>
							</xsl:choose>
						</nobr>
					</xsl:when>
					<xsl:when
						test="count(//*[@ID=$tableName]//repeatedrow/child::*[position()=$counter]/child::*)&gt;0">
						<xsl:for-each
							select="//*[@ID=$tableName]//repeatedrow/child::*[position()=$counter]/*[position()=1]">
							<xsl:choose>
								<xsl:when test="@BIND and not(@ONOBJECTINIT)">
									<xsl:call-template name="buildInnerControl">
										<xsl:with-param name="data">
											<xsl:value-of select="$celldata"/>
										</xsl:with-param>
										<xsl:with-param name="enum">
											<xsl:value-of select="$innercontrol_enum"/>
										</xsl:with-param>
										<xsl:with-param name="bind">
											<xsl:value-of select="$innercontrol_datapath"/>
										</xsl:with-param>
										<xsl:with-param name="r_pos">
											<xsl:value-of select="$rowPos"/>
										</xsl:with-param>
										<xsl:with-param name="cell_pos">
											<xsl:value-of select="$counter"/>
										</xsl:with-param>
										<xsl:with-param name="tblName">
											<xsl:value-of select="$tableName"/>
										</xsl:with-param>
									</xsl:call-template>
								</xsl:when>
								<xsl:otherwise>
									<xsl:call-template name="buildHTML"> </xsl:call-template>
								</xsl:otherwise>
							</xsl:choose>

						</xsl:for-each>
					</xsl:when>
					<xsl:otherwise>
						<xsl:choose>
							<xsl:when test="$enum">
								<xsl:value-of select="$enumData"/>
							</xsl:when>
							<xsl:otherwise>
								<xsl:value-of select="$celldata"/>
							</xsl:otherwise>
						</xsl:choose>
					</xsl:otherwise>
					<!--xsl:otherwise>
						<xsl:choose>
							<xsl:when
								test="count(//*[@ID=$tableName]//repeatedrow/child::*[position()=$counter]/child::*)&gt;0">
								
								<xsl:for-each
									select="//*[@ID=$tableName]//repeatedrow/child::*[position()=$counter]/*">
									<xsl:call-template name="buildHTML"> </xsl:call-template>
								</xsl:for-each>
							</xsl:when>
							<xsl:otherwise>
								<xsl:choose>
									<xsl:when test="$enum">
										<xsl:value-of select="$enumData"/>
									</xsl:when>
									<xsl:otherwise>
										<xsl:value-of select="$celldata"/>
									</xsl:otherwise>
								</xsl:choose>
							</xsl:otherwise>
						</xsl:choose>
					</xsl:otherwise-->
				</xsl:choose>
				<!--xsl:if
					test="count(//*[@ID=$tableName]//repeatedrow/child::*[position()=$counter]/child::*)&gt;0">
					<xsl:for-each
						select="//*[@ID=$tableName]//repeatedrow/child::*[position()=$counter]/*">
						<xsl:choose>
							<xsl:when test="@BIND">
								<xsl:call-template name="buildInnerControl">
									<xsl:with-param name="data">
										<xsl:value-of select="$datanode"/>
									</xsl:with-param>
									
								</xsl:call-template>
							</xsl:when>
							<xsl:otherwise><xsl:call-template name="buildHTML"> </xsl:call-template></xsl:otherwise>
						</xsl:choose>
						
					</xsl:for-each>
				</xsl:if-->


			</td>


			<xsl:call-template name="CreateRepeatedTableCell">
				<xsl:with-param name="cntCells">
					<xsl:value-of select="number($cntCells)"/>
				</xsl:with-param>
				<xsl:with-param name="counter">
					<xsl:value-of select="number($counter + 1)"/>
				</xsl:with-param>
				<xsl:with-param name="tableName">
					<xsl:value-of select="$tableName"/>
				</xsl:with-param>
				<xsl:with-param name="rowPos">
					<xsl:value-of select="$rowPos"/>
				</xsl:with-param>

			</xsl:call-template>

		</xsl:if>


	</xsl:template>

	<!--   *******repeatedtable templates ********** end     -->


	<!--   *******bindingata templates ********** begin     -->

	<xsl:template name="buildInnerControl">
		<xsl:param name="data"/>
		<xsl:param name="enum"/>
		<xsl:param name="bind"/>
		<xsl:param name="r_pos"/>
		<xsl:param name="cell_pos"/>
		<xsl:param name="tblName"/>
		<xsl:variable name="enumNodeName">
			<xsl:choose>
				<xsl:when test="$enum='true'">
					<xsl:call-template name="FindDestNodeName">
						<xsl:with-param name="path">
							<xsl:value-of select="$bind"/>
						</xsl:with-param>
					</xsl:call-template>
				</xsl:when>
				<xsl:otherwise>0</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		<xsl:variable name="cntr_data">
			<xsl:choose>
				<xsl:when test="$enum='true'">
					<xsl:value-of
						select="//ENUM/child::*[name()=$enumNodeName]/child::*[@VALUE[.=$data]]/text()"
					/>
				</xsl:when>
				<xsl:otherwise>
					<xsl:value-of select="$data"/>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		<xsl:choose>
			<xsl:when test="name()='inputtext'">
				<xsl:call-template name="CreateInputText">
					<xsl:with-param name="data">
						<xsl:value-of select="$cntr_data"/>
					</xsl:with-param>
					<xsl:with-param name="row_pos">
						<xsl:value-of select="$r_pos"/>
					</xsl:with-param>
					<xsl:with-param name="cell_pos">
						<xsl:value-of select="$cell_pos"/>
					</xsl:with-param>
					<xsl:with-param name="tableID">
						<xsl:value-of select="$tblName"/>
					</xsl:with-param>
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="name()='combobox'  or  name()='select'">
				<xsl:call-template name="CreateComboBox">
					<xsl:with-param name="data">
						<xsl:value-of select="$cntr_data"/>
					</xsl:with-param>
					<xsl:with-param name="row_pos">
						<xsl:value-of select="$r_pos"/>
					</xsl:with-param>
					<xsl:with-param name="cell_pos">
						<xsl:value-of select="$cell_pos"/>
					</xsl:with-param>
					<xsl:with-param name="tableID">
						<xsl:value-of select="$tblName"/>
					</xsl:with-param>
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="name()='span'">
				<xsl:call-template name="CreateSpan">
					<xsl:with-param name="data">
						<xsl:value-of select="$cntr_data"/>
					</xsl:with-param>
					<xsl:with-param name="row_pos">
						<xsl:value-of select="$r_pos"/>
					</xsl:with-param>
					<xsl:with-param name="cell_pos">
						<xsl:value-of select="$cell_pos"/>
					</xsl:with-param>
					<xsl:with-param name="tableID">
						<xsl:value-of select="$tblName"/>
					</xsl:with-param>
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="name()='checkbox'">
				<xsl:call-template name="CreateCheckBox">
					<xsl:with-param name="data">
						<xsl:value-of select="$cntr_data"/>
					</xsl:with-param>
					<xsl:with-param name="row_pos">
						<xsl:value-of select="$r_pos"/>
					</xsl:with-param>
					<xsl:with-param name="cell_pos">
						<xsl:value-of select="$cell_pos"/>
					</xsl:with-param>
					<xsl:with-param name="tableID">
						<xsl:value-of select="$tblName"/>
					</xsl:with-param>
				</xsl:call-template>
			</xsl:when>
		</xsl:choose>
	</xsl:template>

	<xsl:template name="CreateControlManager">
		<xsl:variable name="id">
			<xsl:choose>
				<xsl:when test="@ID[.!='']">
					<xsl:value-of select="@ID"/>
				</xsl:when>
				<xsl:otherwise/>
			</xsl:choose>
		</xsl:variable>
		<xsl:variable name="bind">
			<xsl:choose>
				<xsl:when test="@BIND_POST">
					<xsl:value-of select="@BIND_POST"/>
				</xsl:when>
				<xsl:when test="@BIND[.!='']">
					<xsl:value-of select="@BIND"/>
				</xsl:when>
				<xsl:otherwise/>
			</xsl:choose>
		</xsl:variable>
		<xsl:variable name="submit">
			<xsl:choose>
				<xsl:when test="@SUBMIT[.='true']">true</xsl:when>
				<xsl:otherwise>false</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		<xsl:variable name="valid_type">
			<xsl:value-of select="@VALID_TYPE"/>
		</xsl:variable>
		<xsl:variable name="field_name">
			<xsl:value-of select="@FIELD_NAME"/>
		</xsl:variable>
		<xsl:variable name="mandatory">
			<xsl:value-of select="@MANDATORY"/>
		</xsl:variable>
		<xsl:variable name="filter">
			<xsl:value-of select="@FILTER"/>
		</xsl:variable>
		<xsl:variable name="position">
			<xsl:value-of select="@POSITION"/>
		</xsl:variable>
		<xsl:variable name="enum">
			<xsl:value-of select="@ENUM"/>
		</xsl:variable>
		<xsl:variable name="min_val">
			<xsl:value-of select="@MIN_VALUE"/>
		</xsl:variable>
		<xsl:variable name="max_val">
			<xsl:value-of select="@MAX_VALUE"/>
		</xsl:variable>
		<xsl:variable name="min_ctr">
			<xsl:value-of select="@MIN_CTR"/>
		</xsl:variable>
		<xsl:variable name="max_ctr">
			<xsl:value-of select="@MAX_CTR"/>
		</xsl:variable>
		<xsl:variable name="event">
			<xsl:choose>
				<xsl:when test="name()='inputtext'">change</xsl:when>
				<xsl:when test="name()='textarea'">change</xsl:when>
				<xsl:when test="name()='combobox'">change</xsl:when>
				<xsl:when test="name()='checkbox'">click</xsl:when>
			</xsl:choose>
		</xsl:variable>
		<xsl:variable name="msg_id">
			<xsl:value-of select="@MSG_ID"/>
		</xsl:variable> ControlManager.create('<xsl:value-of select="$id"/>', '<xsl:value-of
			select="$bind"/>', '<xsl:value-of select="$enum"/>', '<xsl:value-of select="$valid_type"
		/>', '<xsl:value-of select="$event"/>', '<xsl:value-of select="$submit"/>', '<xsl:value-of
			select="$field_name"/>', '<xsl:value-of select="$mandatory"/>', '<xsl:value-of
			select="$min_val"/>', '<xsl:value-of select="$max_val"/> ', '<xsl:value-of
			select="$filter"/>','<xsl:value-of select="$msg_id"/>') </xsl:template>

	<xsl:template name="FindData">
		<xsl:param name="nodename"/>
		<xsl:param name="tail"/>
		<xsl:param name="outerdata">false</xsl:param>
		<xsl:param name="rowPos"/>
		<xsl:param name="posCell"/>
		<xsl:param name="filter"/>

		<xsl:choose>
			<xsl:when test="$outerdata != 'true'">
				<xsl:for-each select="./descendant::*">
					<xsl:variable name="destinationNode">
						<xsl:choose>
							<xsl:when test="contains($tail,'/')">
								<xsl:value-of select="substring-before($tail,'/')"/>
							</xsl:when>
							<xsl:otherwise>
								<xsl:value-of select="$tail"/>
							</xsl:otherwise>
						</xsl:choose>
					</xsl:variable>

					<xsl:if test="name()=$destinationNode">
						<xsl:choose>
							<xsl:when test="contains($tail,'/')">
								<xsl:call-template name="FindData">
									<xsl:with-param name="nodename">
										<xsl:value-of select="substring-before($tail,'/')"/>
									</xsl:with-param>
									<xsl:with-param name="tail">
										<xsl:value-of select="substring-after($tail,'/')"/>
									</xsl:with-param>
									<xsl:with-param name="outerdata"/>
									<xsl:with-param name="rowPos"/>
									<xsl:with-param name="posCell"/>
									<xsl:with-param name="filter">
										<xsl:value-of select="$filter"/>
									</xsl:with-param>
								</xsl:call-template>
							</xsl:when>
							<xsl:otherwise>
								<xsl:choose>
									<xsl:when test="string-length($filter)&gt;0">
										<xsl:choose>
											<xsl:when test="contains($filter,'&amp;')">
												<xsl:if
												test="../*[name()=substring-before(substring-before($filter,'&amp;'),'=')]/text()=substring-after(substring-before($filter,'&amp;'),'=')">
												<xsl:if
												test="../*[name()=substring-before(substring-after($filter,'&amp;'),'=')]/text()=substring-after(substring-after($filter,'&amp;'),'=')">
												<xsl:value-of select="./text()"
												disable-output-escaping="yes"/>
												</xsl:if>
												</xsl:if>
											</xsl:when>
											<xsl:otherwise>
												<xsl:if
												test="../*[name()=substring-before($filter,'=')]/text()=substring-after($filter,'=')">
												<xsl:value-of select="./text()"
												disable-output-escaping="yes"/>
												</xsl:if>
											</xsl:otherwise>
										</xsl:choose>
										<!--xsl:if test="../*[name()=substring-before($filter,'=')]/text()=substring-after($filter,'=')">
				                            <xsl:value-of select="./text()"/>
				                      </xsl:if-->
									</xsl:when>
									<xsl:otherwise>
										<xsl:value-of select="./text()"
											disable-output-escaping="yes"/>
									</xsl:otherwise>
								</xsl:choose>

							</xsl:otherwise>
						</xsl:choose>
					</xsl:if>
				</xsl:for-each>
			</xsl:when>
			<xsl:otherwise>

				<xsl:variable name="outerTable" select="//*[name()=$nodename]"/>
				<xsl:variable name="destinationRowNodeName">
					<xsl:choose>
						<xsl:when test="contains($tail,'/')">
							<xsl:value-of select="substring-before($tail,'/')"/>
						</xsl:when>
						<xsl:otherwise>
							<xsl:value-of select="$tail"/>
						</xsl:otherwise>
					</xsl:choose>
				</xsl:variable>
				<xsl:for-each select="$outerTable/descendant::*[name()=$destinationRowNodeName]">
					<xsl:choose>
						<xsl:when test="name()=$destinationRowNodeName and position()=$rowPos">
							<xsl:call-template name="FindData">
								<xsl:with-param name="nodename">
									<xsl:value-of select="substring-before($tail,'/')"/>
								</xsl:with-param>
								<xsl:with-param name="tail">
									<xsl:value-of select="substring-after($tail,'/')"/>
								</xsl:with-param>
								<xsl:with-param name="outerdata"/>
								<xsl:with-param name="rowPos"/>
								<xsl:with-param name="posCell"/>
								<xsl:with-param name="filter">
									<xsl:value-of select="$filter"/>
								</xsl:with-param>
							</xsl:call-template>
						</xsl:when>
						<xsl:otherwise> </xsl:otherwise>
					</xsl:choose>
				</xsl:for-each>
			</xsl:otherwise>
		</xsl:choose>

	</xsl:template>
	<!--   *******bindingata templates ********** end     -->

	<!--   *******BindingComboData templates ********** begin   -->
	<xsl:template name="FindComboData">
		<xsl:param name="nodename"/>
		<xsl:param name="tail"/>
		<xsl:param name="nodename_value">0</xsl:param>

		<xsl:for-each select="./*">

			<xsl:variable name="search_value">
				<xsl:choose>
					<xsl:when test="$nodename_value!=0">
						<xsl:value-of select="substring-after($nodename_value,'/')"/>
					</xsl:when>
					<xsl:otherwise>0</xsl:otherwise>
				</xsl:choose>
			</xsl:variable>
			<xsl:variable name="destinationNode">
				<xsl:choose>
					<xsl:when test="contains($tail,'/')">
						<xsl:value-of select="substring-before($tail,'/')"/>
					</xsl:when>
					<xsl:otherwise>
						<xsl:value-of select="$tail"/>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:variable>

			<xsl:if test="name()=$destinationNode">

				<xsl:choose>
					<xsl:when test="contains($tail,'/')">
						<xsl:call-template name="FindComboData">
							<xsl:with-param name="nodename">
								<xsl:value-of select="substring-before($tail,'/')"/>
							</xsl:with-param>
							<xsl:with-param name="tail">
								<xsl:value-of select="substring-after($tail,'/')"/>
							</xsl:with-param>
							<xsl:with-param name="nodename_value">
								<xsl:value-of select="$search_value"/>
							</xsl:with-param>
						</xsl:call-template>
					</xsl:when>
					<xsl:otherwise>
						<xsl:variable name="valueNodeName">
							<xsl:choose>
								<xsl:when test="$nodename_value!=0">
									<xsl:call-template name="FindDestNodeName">
										<xsl:with-param name="path">
											<xsl:value-of select="$nodename_value"/>
										</xsl:with-param>
									</xsl:call-template>
								</xsl:when>
								<xsl:otherwise>0</xsl:otherwise>
							</xsl:choose>
						</xsl:variable>
						<option>
							<xsl:attribute name="value">
								<xsl:choose>
									<xsl:when test="$valueNodeName!=0">
										<xsl:value-of select="../*[name()=$valueNodeName]/text()"/>
									</xsl:when>
									<xsl:otherwise>
										<xsl:value-of select="./text()"/>
									</xsl:otherwise>
								</xsl:choose>
							</xsl:attribute>
							<xsl:value-of select="./text()"/>
						</option>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:if>

		</xsl:for-each>


	</xsl:template>
	<!--   *******BindingComboData templates ********** end   -->
	<!-- find destination nodename in path  *** begin  -->
	<xsl:template name="FindDestNodeName">
		<xsl:param name="path"/>
		<xsl:choose>
			<xsl:when test="contains($path,'/')">
				<xsl:call-template name="FindDestNodeName">
					<xsl:with-param name="path">
						<xsl:value-of select="substring-after($path,'/')"/>
					</xsl:with-param>
				</xsl:call-template>

			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="$path"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<xsl:template name="GetData">
		<xsl:variable name="path">
			<xsl:choose>
				<xsl:when test="@BIND">
					<xsl:value-of select="@BIND"/>
				</xsl:when>
				<xsl:otherwise> 0 </xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		<xsl:variable name="datanode" select="//*[name()=substring-before($path,'/')]"/>
		<xsl:variable name="pathdata">
			<xsl:choose>
				<xsl:when test="$path!=0">
					<xsl:choose>
						<xsl:when test="contains(substring-after($path,'/'),'/')">
							<xsl:for-each select="$datanode/descendant::*">
								<xsl:call-template name="FindData">
									<xsl:with-param name="nodename">
										<xsl:value-of
											select="substring-before(substring-after($path,'/'),'/')"
										/>
									</xsl:with-param>
									<xsl:with-param name="tail">
										<xsl:value-of
											select="substring-after(substring-after($path,'/'),'/')"
										/>
									</xsl:with-param>
								</xsl:call-template>
							</xsl:for-each>
						</xsl:when>
						<xsl:otherwise>
							<xsl:value-of
								select="normalize-space(//*[name()=substring-after($path,'/')]/text())"
								disable-output-escaping="yes"/>
						</xsl:otherwise>
					</xsl:choose>
				</xsl:when>
				<xsl:otherwise>
					<xsl:value-of select="normalize-space(./text())" disable-output-escaping="yes"/>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		<xsl:variable name="enum" select="@ENUM"/>
		<xsl:variable name="enumNodeName">
			<xsl:call-template name="FindDestNodeName">
				<xsl:with-param name="path">
					<xsl:value-of select="normalize-space($path)"/>
				</xsl:with-param>
			</xsl:call-template>
		</xsl:variable>
		<xsl:variable name="enumData">
			<xsl:value-of
				select="//ENUM/child::*[name()=$enumNodeName]/child::*[@VALUE[.=normalize-space($pathdata)]]/text()"
				disable-output-escaping="yes"/>
		</xsl:variable>
		<xsl:variable name="data">
			<xsl:choose>
				<xsl:when test="$enum">
					<xsl:value-of select="$enumData"/>
				</xsl:when>
				<xsl:otherwise>
					<xsl:value-of select="normalize-space($pathdata)" disable-output-escaping="yes"
					/>
				</xsl:otherwise>
			</xsl:choose>

		</xsl:variable>
		<xsl:value-of select="$data"/>
	</xsl:template>


	<xsl:template name="GetBitMaskData">
		<xsl:param name="tail"/>
		<xsl:param name="tablename"/>
		<xsl:param name="posCell"/>

		<xsl:for-each select="./descendant::*">
			<xsl:variable name="destinationNode">
				<xsl:choose>
					<xsl:when test="contains($tail,'/')">
						<xsl:value-of select="substring-before($tail,'/')"/>
					</xsl:when>
					<xsl:otherwise>
						<xsl:value-of select="$tail"/>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:variable>

			<xsl:if test="name()=$destinationNode">
				<xsl:choose>
					<xsl:when test="contains($tail,'/')">
						<xsl:call-template name="GetBitMaskData">
							<xsl:with-param name="nodename">
								<xsl:value-of select="substring-before($tail,'/')"/>
							</xsl:with-param>
							<xsl:with-param name="tail">
								<xsl:value-of select="substring-after($tail,'/')"/>
							</xsl:with-param>
							<xsl:with-param name="tablename">
								<xsl:value-of select="$tablename"/>
							</xsl:with-param>
							<xsl:with-param name="posCell">
								<xsl:value-of select="$posCell"/>
							</xsl:with-param>

						</xsl:call-template>
					</xsl:when>
					<xsl:otherwise>
						<xsl:variable name="delim">
							<xsl:value-of
								select="//*[@ID=$tablename]//repeatedrow/child::*[position()=$posCell and @TYPE='bitmask']/@DELIMETER"
							/>
						</xsl:variable>
						<xsl:variable name="bmsk_id"
							select="//*[@ID=$tablename]//repeatedrow/child::*[position()=$posCell and @TYPE='bitmask']/@BMSK_ID"/>

						<xsl:call-template name="TranslateBitMask">
							<xsl:with-param name="bitmask">
								<xsl:value-of select="./text()"/>
							</xsl:with-param>
							<xsl:with-param name="bmsk_id">
								<xsl:value-of select="$bmsk_id"/>
							</xsl:with-param>
							<xsl:with-param name="tablename">
								<xsl:value-of select="tablename"/>
							</xsl:with-param>
							<xsl:with-param name="posCell">
								<xsl:value-of select="$posCell"/>
							</xsl:with-param>
							<xsl:with-param name="pos">0</xsl:with-param>
							<xsl:with-param name="delim">
								<xsl:value-of select="$delim"/>
							</xsl:with-param>
						</xsl:call-template>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:if>
		</xsl:for-each>

	</xsl:template>

	<xsl:template name="TranslateBitMask">
		<xsl:param name="bitmask"/>
		<xsl:param name="bmsk_id"/>
		<xsl:param name="tablename"/>
		<xsl:param name="posCell"/>
		<xsl:param name="pos"/>
		<xsl:param name="delim"/>
		<xsl:param name="result"/>



		<xsl:variable name="bits_len">
			<!--xsl:value-of
				select="count(//*[@ID=$tablename]//repeatedrow/child::*[position()=$posCell and @TYPE='bitmask']/*/child::*)"
				/-->
			<xsl:value-of select="count(//bitmask[@ID=$bmsk_id]/*/*)"/>
		</xsl:variable>

		<xsl:choose>
			<xsl:when test="$bits_len &gt; $pos">
				<xsl:variable name="bit">
					<xsl:value-of select="substring($bitmask,number($pos + 1),1)"/>
				</xsl:variable>

				<xsl:variable name="bitvalue">
					<xsl:choose>
						<!--xsl:when test="$bit='1'">
							<xsl:value-of
								select="//*[@ID=$tablename]//repeatedrow/child::*[position()=$posCell and @TYPE='bitmask']/*/child::*[name()=concat('bit',$pos)]/text()"
							/>
							</xsl:when-->
						<xsl:when test="$bit='1'">
							<xsl:value-of
								select="//bitmask[@ID=$bmsk_id]/*/child::*[name()=concat('bit',$pos)]/text()"
							/>
						</xsl:when>
						<xsl:otherwise/>
					</xsl:choose>
				</xsl:variable>
				<xsl:variable name="concat">
					<xsl:choose>
						<xsl:when
							test="string-length($result)=0 and string-length($bitvalue) &gt; 0">
							<xsl:value-of select="$bitvalue"/>
						</xsl:when>
						<xsl:when test="string-length($bitvalue) &gt; 0">

							<xsl:value-of select="concat(concat($result,$delim),$bitvalue)"/>

						</xsl:when>
						<xsl:otherwise>
							<xsl:value-of select="$result"/>
						</xsl:otherwise>
					</xsl:choose>
				</xsl:variable>


				<xsl:call-template name="TranslateBitMask">
					<xsl:with-param name="bitmask">
						<xsl:value-of select="$bitmask"/>
					</xsl:with-param>
					<xsl:with-param name="bmsk_id">
						<xsl:value-of select="$bmsk_id"/>
					</xsl:with-param>
					<xsl:with-param name="tablename">
						<xsl:value-of select="$tablename"/>
					</xsl:with-param>
					<xsl:with-param name="posCell">
						<xsl:value-of select="$posCell"/>
					</xsl:with-param>
					<xsl:with-param name="pos">
						<xsl:value-of select="number($pos + 1)"/>
					</xsl:with-param>
					<xsl:with-param name="result">
						<xsl:value-of select="$concat"/>
					</xsl:with-param>
					<xsl:with-param name="delim">
						<xsl:value-of select="$delim"/>
					</xsl:with-param>
				</xsl:call-template>

			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="$result"/>
			</xsl:otherwise>
		</xsl:choose>


	</xsl:template>
	<!-- find last nodename in path  *** end  -->
	<!--   *******bindingata templates ********** end     -->



	<xsl:template name="CreateCheckBox">
		<xsl:param name="data"/>
		<xsl:param name="row_pos"/>
		<xsl:param name="cell_pos"/>
		<xsl:param name="tableID"/>
		<xsl:element name="input">
			<xsl:variable name="pathcell">
				<xsl:choose>
					<xsl:when test="@BIND">
						<xsl:value-of select="@BIND"/>
					</xsl:when>
					<xsl:otherwise>0</xsl:otherwise>
				</xsl:choose>
			</xsl:variable>

			<xsl:variable name="datapath">
				<xsl:choose>
					<xsl:when test="contains($pathcell,'/')">
						<xsl:value-of select="substring-before($pathcell,'/')"/>
					</xsl:when>
					<xsl:otherwise>
						<xsl:value-of select="$pathcell"/>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:variable>

			<xsl:variable name="enumNodeName">
				<xsl:choose>
					<xsl:when test="@ENUM and @ENUM[.!='']">
						<xsl:call-template name="FindDestNodeName">
							<xsl:with-param name="path">
								<xsl:value-of select="$pathcell"/>
							</xsl:with-param>
						</xsl:call-template>
					</xsl:when>
					<xsl:otherwise>0</xsl:otherwise>
				</xsl:choose>

			</xsl:variable>


			<xsl:variable name="datanode" select="//*[name()=$datapath]"/>

			<xsl:choose>
				<xsl:when test="$row_pos">
					<xsl:attribute name="id">
						<xsl:value-of
							select="concat('chb_',concat($cell_pos - 1,concat('_',concat(concat($row_pos - 1,'_'),$tableID))))"
						/>
					</xsl:attribute>
				</xsl:when>
				<xsl:otherwise>
					<xsl:if test="@ID[.!= '']">
						<xsl:attribute name="id">
							<xsl:value-of select="@ID"/>
						</xsl:attribute>
					</xsl:if>
				</xsl:otherwise>
			</xsl:choose>

			<xsl:if test="@TOOLTIP">
				<xsl:attribute name="title">
					<xsl:value-of select="@TOOLTIP"/>
				</xsl:attribute>
			</xsl:if>
			<xsl:attribute name="type">checkbox</xsl:attribute>
			<xsl:if test="@ENABLED[.= 'false']">
				<xsl:attribute name="disabled">true</xsl:attribute>
			</xsl:if>
			<xsl:if test="@TABINDEX[.!= '']">
				<xsl:attribute name="tabindex">
					<xsl:value-of select="@TABINDEX"/>
				</xsl:attribute>
			</xsl:if>
			<xsl:if test="@CHECKED[. = 'true']">
				<xsl:attribute name="checked">true</xsl:attribute>
				<xsl:attribute name="value">1</xsl:attribute>
			</xsl:if>
			<xsl:if test="@CHECKED_VALUE">
				<xsl:attribute name="checked_value"><xsl:value-of select="@CHECKED_VALUE"/></xsl:attribute>
	    	</xsl:if>
	    	<xsl:if test="@UNCHECKED_VALUE">
				<xsl:attribute name="unchecked_value"><xsl:value-of select="@UNCHECKED_VALUE"/></xsl:attribute>
	    	</xsl:if>
			<xsl:if test="@BIND">
				<xsl:attribute name="bind"><xsl:value-of select="@BIND"/></xsl:attribute>
				<xsl:variable name="ch_data">
					<xsl:choose>
						<xsl:when test="$tableMode=1">
							<xsl:value-of select="@VALUE"/>
						</xsl:when>
						<xsl:when test="$pathcell != 0">
							<xsl:choose>
								<xsl:when test="$data">
									<xsl:value-of select="$data"/>
								</xsl:when>
								<xsl:when test="contains($pathcell,'/')">

									<xsl:for-each select="$datanode">

										<xsl:call-template name="FindData">
											<xsl:with-param name="nodename">
												<xsl:value-of
												select="substring-before($pathcell,'/')"/>
											</xsl:with-param>
											<xsl:with-param name="tail">
												<xsl:value-of
												select="substring-after($pathcell,'/')"/>
											</xsl:with-param>
										</xsl:call-template>
									</xsl:for-each>
								</xsl:when>
								<xsl:otherwise> </xsl:otherwise>
							</xsl:choose>
						</xsl:when>
						<xsl:otherwise>0</xsl:otherwise>
					</xsl:choose>
				</xsl:variable>
				<xsl:if test="@CHECKED_VALUE and @CHECKED_VALUE[.=$ch_data]">
					<xsl:attribute name="checked">true</xsl:attribute>
				</xsl:if>
				<xsl:attribute name="value">
					<xsl:value-of select="$ch_data"/>
				</xsl:attribute>
			</xsl:if>
			<xsl:choose>
				<xsl:when test="(@BIND and @SUBMIT[.='true']) or @VALID_TYPE">
					<xsl:attribute name="onclick">
						<xsl:choose>
							<xsl:when test="@ONCLICK">
								<xsl:value-of select="@ONCLICK"/>;<xsl:call-template
									name="CreateControlManager"/>
							</xsl:when>
							<xsl:otherwise>
								<xsl:call-template name="CreateControlManager"/>
							</xsl:otherwise>
						</xsl:choose>
					</xsl:attribute>
				</xsl:when>
				<xsl:otherwise>
					<xsl:if test="@ONCLICK">
						<xsl:attribute name="onclick">
							<xsl:value-of select="@ONCLICK"/>
						</xsl:attribute>
					</xsl:if>
				</xsl:otherwise>
			</xsl:choose>


		</xsl:element>


	</xsl:template>

	<xsl:template name="CreateImage">
		<xsl:element name="IMG">
			<xsl:if test="@ID">
				<xsl:attribute name="id">
					<xsl:value-of select="@ID"/>
				</xsl:attribute>
			</xsl:if>
			<xsl:if test="@NAME">
				<xsl:attribute name="name">
					<xsl:value-of select="@NAME"/>
				</xsl:attribute>
			</xsl:if>
			<xsl:attribute name="SRC">
				<xsl:value-of select="@SRC"/>
			</xsl:attribute>
			<xsl:if test="@STYLE">
				<xsl:attribute name="style">
					<xsl:value-of select="@STYLE"/>
				</xsl:attribute>
			</xsl:if>
			<xsl:if test="@TOOLTIP[.!= '']">
				<xsl:attribute name="title">
					<xsl:value-of select="@TOOLTIP"/>
				</xsl:attribute>
			</xsl:if>
			<xsl:if test="@ENABLED[.= 'false']">
				<xsl:attribute name="disabled">true</xsl:attribute>
			</xsl:if>
			<xsl:if test="@ONCLICK[.!= '']">
				<xsl:attribute name="onclick">
					<xsl:value-of select="@ONCLICK"/>
				</xsl:attribute>
			</xsl:if>
			<xsl:if test="@ONMOUSEMOVE[.!= '']">
				<xsl:attribute name="onmousemove">
					<xsl:value-of select="@ONMOUSEMOVE"/>
				</xsl:attribute>
			</xsl:if>
			<xsl:if test="@ONMOUSEOUT[.!= '']">
				<xsl:attribute name="onmouseout">
					<xsl:value-of select="@ONMOUSEOUT"/>
				</xsl:attribute>
			</xsl:if>
			<xsl:if test="@ONMOUSEDOWN[.!= '']">
				<xsl:attribute name="onmousedown">
					<xsl:value-of select="@ONMOUSEDOWN"/>
				</xsl:attribute>
			</xsl:if>
		</xsl:element>
		<xsl:if test="@TITLE[.!= '']">
			<xsl:if test="@TITLE-SIZE[.!= '']">
				<xsl:element name="label">
					<xsl:attribute name="name">L_<xsl:value-of select="@NAME"/></xsl:attribute>
					<xsl:attribute name="id">L_<xsl:value-of select="@NAME"/></xsl:attribute>
					<xsl:attribute name="style">cursor:hand;<xsl:if test="@TOP">top:<xsl:value-of
								select="@TOP"/>px;</xsl:if><xsl:if test="@LEFT">left:<xsl:value-of
								select="number(@LEFT)-number(@TITLE-SIZE)"/>px;</xsl:if><xsl:if
							test="@POSITION">position:<xsl:value-of select="@POSITION"/>;</xsl:if>
						<xsl:if test="@VISIBLE[.= 'hidden']">visibility:<xsl:value-of
								select="@VISIBLE"/>;display:none;</xsl:if><xsl:if
							test="@VISIBLE[.= 'visible']"> visibility:<xsl:value-of
								select="@VISIBLE"/>;display:block;</xsl:if><xsl:if
							test="@DISPLAY[.= 'none']"
							>visibility:hidden;display:none;</xsl:if><xsl:if
							test="@DISPLAY[.= 'block']">visibility:visible;display:block;</xsl:if></xsl:attribute>
					<xsl:value-of select="@TITLE"/>
				</xsl:element>
			</xsl:if>
		</xsl:if>
	</xsl:template>

	<xsl:template name="CreateDivision">

		<div>
			<xsl:if test="@ID[.!='']">
				<xsl:attribute name="id">
					<xsl:value-of select="@ID"/>
				</xsl:attribute>
			</xsl:if>
			<xsl:if test="@NAME[.!='']">
				<xsl:attribute name="name">
					<xsl:value-of select="@NAME"/>
				</xsl:attribute>
			</xsl:if>
			<xsl:if test="@WIDTH">
				<xsl:attribute name="width">
					<xsl:value-of select="@WIDTH"/>
				</xsl:attribute>
			</xsl:if>
			<xsl:if test="@HEIGHT[.!= '']">
				<xsl:attribute name="height">
					<xsl:value-of select="@HEIGHT"/>
				</xsl:attribute>
			</xsl:if>
			<xsl:if test="@CLASS[.!= '']">
				<xsl:attribute name="class">
					<xsl:value-of select="@CLASS"/>
				</xsl:attribute>
			</xsl:if>
			<xsl:if test="@STYLE">
				<xsl:attribute name="style">
					<xsl:value-of select="@STYLE"/>
				</xsl:attribute>
			</xsl:if>
			<xsl:if test="@ONCLICK">
				<xsl:attribute name="onlick">
					<xsl:value-of select="@ONCLICK"/>
				</xsl:attribute>
			</xsl:if>
			<xsl:if test="@ONMOUSEOVER">
				<xsl:attribute name="onmouseover">
					<xsl:value-of select="@ONMOUSEOVER"/>
				</xsl:attribute>
			</xsl:if>
			<xsl:if test="@ONMOUSEOUT">
				<xsl:attribute name="onmouseout">
					<xsl:value-of select="@ONMOUSEOUT"/>
				</xsl:attribute>
			</xsl:if>
			<xsl:if test="@TOOLTIP">
				<xsl:attribute name="title">
					<xsl:value-of select="@TOOLTIP"/>
				</xsl:attribute>
			</xsl:if>
			<xsl:for-each select="./*">
				<xsl:call-template name="buildHTML"> </xsl:call-template>

			</xsl:for-each>
			<!--xsl:value-of select="./text()"/-->
		</div>

	</xsl:template>




	<xsl:template name="CreateInputText">
		<xsl:param name="data"/>
		<xsl:param name="row_pos"/>
		<xsl:param name="cell_pos"/>
		<xsl:param name="tableID"/>
		<xsl:element name="input">
			<xsl:attribute name="type">text</xsl:attribute>
			<xsl:if test="@NAME[.!= '']">
				<xsl:attribute name="name">
					<xsl:value-of select="@NAME"/>
				</xsl:attribute>
			</xsl:if>
			<xsl:choose>
				<xsl:when test="$row_pos">
					<xsl:attribute name="id">
						<xsl:value-of
							select="concat('txt_',concat($cell_pos - 1,concat('_',concat(concat($row_pos - 1,'_'),$tableID))))"
						/>
					</xsl:attribute>
				</xsl:when>
				<xsl:otherwise>
					<xsl:if test="@ID[.!= '']">
						<xsl:attribute name="id">
							<xsl:value-of select="@ID"/>
						</xsl:attribute>
					</xsl:if>
				</xsl:otherwise>
			</xsl:choose>


			<xsl:if test="@WIDTH[.!= '']">
				<xsl:attribute name="width">
					<xsl:value-of select="@WIDTH"/>
				</xsl:attribute>
			</xsl:if>
			<xsl:if test="@HEIGHT[.!= '']">
				<xsl:attribute name="height">
					<xsl:value-of select="@HEIGHT"/>
				</xsl:attribute>
			</xsl:if>
			<xsl:if test="@TOOLTIP[.!= '']">
				<xsl:attribute name="title">
					<xsl:value-of select="@TOOLTIP"/>
				</xsl:attribute>
			</xsl:if>
			<xsl:if test="@ENABLED[.='false']">
				<xsl:attribute name="disabled">true</xsl:attribute>
			</xsl:if>
			<xsl:if test="@CLASS[.!= '']">
				<xsl:attribute name="class">
					<xsl:value-of select="@CLASS"/>
				</xsl:attribute>
			</xsl:if>

			<xsl:if test="@STYLE">
				<xsl:attribute name="style">
					<xsl:value-of select="@STYLE"/>
				</xsl:attribute>
			</xsl:if>


			<xsl:if test="@MAXLENGTH">
				<xsl:attribute name="maxlength">
					<xsl:value-of select="@MAXLENGTH"/>
				</xsl:attribute>
			</xsl:if>

			<xsl:if test="@READONLY[.= 'true']">
				<xsl:attribute name="readonly">
					<xsl:value-of select="@READONLY"/>
				</xsl:attribute>
			</xsl:if>
			<xsl:choose>
				<xsl:when test="(@BIND and @SUBMIT[.='true'])or @VALID_TYPE">
					<xsl:attribute name="onchange">
						<xsl:choose>
							<xsl:when test="@ONCHANGE">
								<xsl:value-of select="@ONCHANGE"/>;<xsl:call-template
									name="CreateControlManager"/>
							</xsl:when>
							<xsl:otherwise>
								<xsl:call-template name="CreateControlManager"/>
							</xsl:otherwise>
						</xsl:choose>

					</xsl:attribute>
				</xsl:when>
				<xsl:otherwise>
					<xsl:if test="@ONCHANGE">
						<xsl:attribute name="onchange">
							<xsl:value-of select="@ONCHANGE"/>
						</xsl:attribute>
					</xsl:if>
				</xsl:otherwise>
			</xsl:choose>

			<xsl:if test="@ONCLICK">
				<xsl:attribute name="onclick">
					<xsl:value-of select="@ONCLICK"/>
				</xsl:attribute>
			</xsl:if>

			<xsl:if test="@ONKEYDOWN">
				<xsl:attribute name="onkeydown">
					<xsl:value-of select="@ONKEYDOWN"/>
				</xsl:attribute>
			</xsl:if>

			<xsl:if test="@ONKEYUP">
				<xsl:attribute name="onkeyup">
					<xsl:value-of select="@ONKEYUP"/>
				</xsl:attribute>
			</xsl:if>

			<xsl:attribute name="value">
				<xsl:choose>
					<xsl:when test="$tableMode=1">
					  <xsl:choose>
					     <xsl:when test="./text()='' and @DEFAULT_VALUE[.!='']">
					        <xsl:value-of select="@DEFAULT_VALUE"/>
					     </xsl:when>
					     <xsl:otherwise>
					       <xsl:value-of select="./text()" disable-output-escaping="yes"/>
					     </xsl:otherwise>
					  </xsl:choose>
						
					</xsl:when>
					<xsl:when test="$data">
						<xsl:value-of select="$data"/>
					</xsl:when>
					<xsl:when test="@DEFAULT_VALUE[.!='']">
						<xsl:value-of select="@DEFAULT_VALUE"/>
					</xsl:when>
					<xsl:otherwise>
						<xsl:call-template name="GetData"/>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:attribute>
		</xsl:element>

	</xsl:template>

	<xsl:template name="CreateComboBox">
		<xsl:param name="data"/>
		<xsl:param name="row_pos"/>
		<xsl:param name="cell_pos"/>
		<xsl:param name="tableID"/>
		<xsl:element name="select">

			<xsl:if test="@MULTIPLE[.= 'true']">
				<xsl:attribute name="MULTIPLE">true</xsl:attribute>
			</xsl:if>
			<xsl:if test="@CLASS">
				<xsl:attribute name="class">
					<xsl:value-of select="@CLASS"/>
				</xsl:attribute>
			</xsl:if>
			<xsl:if test="@SIZE">
				<xsl:attribute name="size">
					<xsl:value-of select="@SIZE"/>
				</xsl:attribute>
			</xsl:if>
			<xsl:if test="@WIDTH">
				<xsl:attribute name="style">WIDTH:<xsl:value-of select="@WIDTH"/>;</xsl:attribute>
			</xsl:if>

			<xsl:choose>
				<xsl:when test="$row_pos">
					<xsl:attribute name="id">
						<xsl:value-of
							select="concat('cmb_',concat($cell_pos - 1,concat('_',concat(concat($row_pos - 1,'_'),$tableID))))"
						/>
					</xsl:attribute>
				</xsl:when>
				<xsl:otherwise>
					<xsl:if test="@ID[.!= '']">
						<xsl:attribute name="id">
							<xsl:value-of select="@ID"/>
						</xsl:attribute>
					</xsl:if>
				</xsl:otherwise>
			</xsl:choose>

			<xsl:attribute name="name">
				<xsl:value-of select="@ID"/>
			</xsl:attribute>
			<xsl:if test="@ENABLED[.= 'false']">
				<xsl:attribute name="disabled">true</xsl:attribute>
			</xsl:if>
			<xsl:if test="@ONCLICK">
				<xsl:attribute name="onclick">
					<xsl:value-of select="@ONCLICK"/>
				</xsl:attribute>
			</xsl:if>
			<xsl:choose>
				<xsl:when test="(@BIND and @SUBMIT[.='true'])or @VALID_TYPE">
					<xsl:attribute name="onchange">
						<xsl:choose>
							<xsl:when test="@ONCHANGE">
								<xsl:value-of select="@ONCHANGE"/>;<xsl:call-template
									name="CreateControlManager"/>
							</xsl:when>
							<xsl:otherwise>
								<xsl:call-template name="CreateControlManager"/>
							</xsl:otherwise>
						</xsl:choose>
					</xsl:attribute>
				</xsl:when>
				<xsl:otherwise>
					<xsl:if test="@ONCHANGE">
						<xsl:attribute name="onchange">
							<xsl:value-of select="@ONCHANGE"/>
						</xsl:attribute>
					</xsl:if>
				</xsl:otherwise>
			</xsl:choose>

			<xsl:variable name="default_value">
				<xsl:value-of select="@DEFAULT_VALUE"/>
			</xsl:variable>
			<xsl:variable name="bind">
				<xsl:choose>
					<xsl:when test="@BIND">
						<xsl:value-of select="@BIND"/>
					</xsl:when>
					<xsl:otherwise>0</xsl:otherwise>
				</xsl:choose>
			</xsl:variable>
			<xsl:variable name="pathoptions_text">
				<xsl:choose>
					<xsl:when test="@LOAD_OPTION_TEXT">
						<xsl:value-of select="@LOAD_OPTION_TEXT"/>
					</xsl:when>
					<xsl:otherwise>0</xsl:otherwise>
				</xsl:choose>
			</xsl:variable>

			<xsl:variable name="pathoptions_value">
				<xsl:choose>
					<xsl:when test="@LOAD_OPTION_VALUE">
						<xsl:value-of select="@LOAD_OPTION_VALUE"/>
					</xsl:when>
					<xsl:otherwise>0</xsl:otherwise>
				</xsl:choose>
			</xsl:variable>
			<xsl:variable name="combopath">
				<xsl:value-of select="substring-before($bind,'/')"/>
			</xsl:variable>
			<xsl:variable name="combobind" select="//*[name()=$combopath]"/>
			<xsl:variable name="optionpath_text">
				<xsl:value-of select="substring-before($pathoptions_text,'/')"/>
			</xsl:variable>


			<xsl:variable name="options_text" select="//*[name()=$optionpath_text]"/>
			<xsl:variable name="optionpath_value">
				<xsl:value-of select="substring-before($pathoptions_value,'/')"/>
			</xsl:variable>
			<xsl:variable name="options_value" select="//*[name()=$optionpath_value]"/>
			<xsl:variable name="prm_nodename">
				<xsl:choose>
					<xsl:when test="contains(substring-after($pathoptions_text,'/'),'/')">
						<xsl:value-of
							select="substring-before(substring-after($pathoptions_text,'/'),'/')"/>
					</xsl:when>
					<xsl:otherwise>
						<xsl:value-of select="substring-after($pathoptions_text,'/')"/>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:variable>
			<xsl:variable name="prm_tail">
				<xsl:choose>
					<xsl:when test="contains(substring-after($pathoptions_text,'/'),'/')">
						<xsl:value-of
							select="substring-after(substring-after($pathoptions_text,'/'),'/')"/>
					</xsl:when>
					<xsl:otherwise>
						<xsl:value-of select="substring-after($pathoptions_text,'/')"/>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:variable>


			<xsl:choose>
				<xsl:when test="count(child::*[name()='option'])&gt;0">
					<xsl:variable name="selData">
						<xsl:choose>

							<xsl:when test="$tableMode=1">
								<xsl:value-of select="@VALUE"/>
							</xsl:when>
							<xsl:when test="$data">
								<xsl:value-of select="$data"/>
							</xsl:when>
							<xsl:otherwise>
								<xsl:for-each select="$combobind">
									<xsl:call-template name="FindData">
										<xsl:with-param name="nodename">
											<xsl:value-of select="$combopath"/>
										</xsl:with-param>
										<xsl:with-param name="tail">
											<xsl:value-of select="substring-after($bind,'/')"/>
										</xsl:with-param>

									</xsl:call-template>
								</xsl:for-each>
							</xsl:otherwise>
						</xsl:choose>
					</xsl:variable>
					<xsl:for-each select="./*">
						<xsl:call-template name="CreateOption">
							<xsl:with-param name="selecteddata">
								<xsl:value-of select="$selData"/>
							</xsl:with-param>
						</xsl:call-template>
					</xsl:for-each>
				</xsl:when>
				<xsl:when test="$pathoptions_text != 0">
					<xsl:choose>
						<xsl:when test="contains(substring-after($pathoptions_text,'/'),'/')">
							<xsl:for-each select="$options_text/descendant::*">
								<xsl:call-template name="FindComboData">
									<xsl:with-param name="nodename">
										<xsl:value-of select="$prm_nodename"/>
									</xsl:with-param>
									<xsl:with-param name="tail">
										<xsl:value-of select="$prm_tail"/>
									</xsl:with-param>
									<xsl:with-param name="nodename_value">
										<xsl:value-of select="$pathoptions_value"/>
									</xsl:with-param>
								</xsl:call-template>
							</xsl:for-each>
						</xsl:when>
						<xsl:when test="contains($pathoptions_text,'/')">
							<xsl:for-each select="$options_text">
								<xsl:call-template name="FindComboData">
									<xsl:with-param name="nodename">
										<xsl:value-of select="$prm_nodename"/>
									</xsl:with-param>
									<xsl:with-param name="tail">
										<xsl:value-of select="$prm_tail"/>
									</xsl:with-param>
									<xsl:with-param name="nodename_value">
										<xsl:value-of select="$pathoptions_value"/>
									</xsl:with-param>
								</xsl:call-template>
							</xsl:for-each>
						</xsl:when>
						<xsl:otherwise>
							<xsl:value-of select="//*[name()=$pathoptions_text]/text()"/>
						</xsl:otherwise>
					</xsl:choose>
				</xsl:when>
				<xsl:otherwise>
					<xsl:for-each select="./*">
						<xsl:call-template name="buildHTML"/>
					</xsl:for-each>
				</xsl:otherwise>
			</xsl:choose>


		</xsl:element>
	</xsl:template>

	<xsl:template name="CreateListHolder">
		<xsl:element name="select">
			<xsl:if test="@MULTIPLE[.= 'true']">
				<xsl:attribute name="MULTIPLE">true</xsl:attribute>
			</xsl:if>
			<xsl:if test="@CLASS">
				<xsl:attribute name="class">
					<xsl:value-of select="@CLASS"/>
				</xsl:attribute>
			</xsl:if>
			<xsl:if test="@STYLE">
				<xsl:attribute name="style">
					<xsl:value-of select="@STYLE"/>
				</xsl:attribute>
			</xsl:if>
			<xsl:if test="@SIZE">
				<xsl:attribute name="size">
					<xsl:value-of select="@SIZE"/>
				</xsl:attribute>
			</xsl:if>
			<xsl:if test="@WIDTH">
				<xsl:attribute name="style">WIDTH:<xsl:value-of select="@WIDTH"/>;</xsl:attribute>
			</xsl:if>
			<xsl:attribute name="id">
				<xsl:value-of select="@ID"/>
			</xsl:attribute>
			<xsl:attribute name="name">
				<xsl:value-of select="@ID"/>
			</xsl:attribute>

			<xsl:if test="@ENABLED[.= 'false']">
				<xsl:attribute name="disabled">true</xsl:attribute>
			</xsl:if>

			<xsl:choose>
				<xsl:when test="@ONCHANGE">
					<xsl:attribute name="onchange">
						<xsl:value-of select="@ONCHANGE"/>
					</xsl:attribute>
				</xsl:when>
			</xsl:choose>
			<xsl:if test="@ONCLICK">
				<xsl:attribute name="onclick">
					<xsl:value-of select="@ONCLICK"/>
				</xsl:attribute>
			</xsl:if>

		</xsl:element>
	</xsl:template>

	<xsl:template name="CreateOption">
		<xsl:param name="selecteddata">null</xsl:param>
		<option value="{@VALUE}">

			<xsl:choose>
				<xsl:when test="@SELECTED[.='true']">
					<xsl:attribute name="selected">selected</xsl:attribute>
				</xsl:when>
				<xsl:when test="@VALUE[.=$selecteddata]">
					<xsl:attribute name="selected">selected</xsl:attribute>
				</xsl:when>
				<xsl:otherwise> </xsl:otherwise>
			</xsl:choose>

			<xsl:value-of select="./text()"/>
		</option>
	</xsl:template>

	<xsl:template name="CreateInnerFrame">
		<iframe>
			<xsl:attribute name="id">
				<xsl:value-of select="@ID"/>
			</xsl:attribute>
			<xsl:attribute name="name">
				<xsl:value-of select="@ID"/>
			</xsl:attribute>
			<xsl:if test="@STYLE">
				<xsl:attribute name="style">
					<xsl:value-of select="@STYLE"/>
				</xsl:attribute>
			</xsl:if>
			<xsl:choose>
				<xsl:when test="@BORDER">
					<xsl:attribute name="frameborder">yes</xsl:attribute>
				</xsl:when>
				<xsl:otherwise>
					<xsl:attribute name="frameborder">no</xsl:attribute>
				</xsl:otherwise>
			</xsl:choose>

			<xsl:choose>
				<xsl:when test="@WIDTH">
					<xsl:attribute name="width">
						<xsl:value-of select="@WIDTH"/>
					</xsl:attribute>
				</xsl:when>
				<xsl:otherwise>
					<xsl:attribute name="width">100%</xsl:attribute>
				</xsl:otherwise>
			</xsl:choose>
			<xsl:choose>
				<xsl:when test="@HEIGHT">
					<xsl:attribute name="height">
						<xsl:value-of select="@HEIGHT"/>
					</xsl:attribute>
				</xsl:when>
				<xsl:otherwise>
					<xsl:attribute name="height">100%</xsl:attribute>
				</xsl:otherwise>
			</xsl:choose>
			<xsl:if test="@SRC">
				<xsl:attribute name="src">
					<xsl:value-of select="@SRC"/>
				</xsl:attribute>
			</xsl:if>
			<xsl:for-each select="./*">
				<xsl:call-template name="buildHTML"> </xsl:call-template>
			</xsl:for-each>
		</iframe>
	</xsl:template>

	<xsl:template name="CreateLink">
		<a>
			<xsl:if test="@ID">
				<xsl:attribute name="id">
					<xsl:value-of select="@ID"/>
				</xsl:attribute>
			</xsl:if>
			<xsl:if test="@STYLE">
				<xsl:attribute name="style">
					<xsl:value-of select="@STYLE"/>
				</xsl:attribute>
			</xsl:if>
			<xsl:if test="@CLASS">
				<xsl:attribute name="class">
					<xsl:value-of select="@CLASS"/>
				</xsl:attribute>
			</xsl:if>
			<xsl:if test="@TOOLTIP">
				<xsl:attribute name="title">
					<xsl:value-of select="@TOOLTIP"/>
				</xsl:attribute>
			</xsl:if>
			<xsl:if test="@ENABLED='false'">
				<xsl:attribute name="disabled">true</xsl:attribute>
			</xsl:if>
			<xsl:attribute name="href">
				<xsl:value-of select="@HREF"/>
			</xsl:attribute>
			<xsl:value-of select="./text()"/>
		</a>
	</xsl:template>


	<xsl:template name="CreateHR">

		<xsl:element name="hr">
			<xsl:if test="@ID">
				<xsl:attribute name="id">
					<xsl:value-of select="@ID"/>
				</xsl:attribute>
			</xsl:if>

			<xsl:if test="@CLASS">
				<xsl:attribute name="class">
					<xsl:value-of select="@CLASS"/>
				</xsl:attribute>
			</xsl:if>

			<xsl:if test="@STYLE">
				<xsl:attribute name="style">
					<xsl:value-of select="@STYLE"/>
				</xsl:attribute>
			</xsl:if>


			<!--  attributes color and size are required for Gecko browser , CSS- attributes doen't work  in HR   -->
			<xsl:if test="@COLOR">
				<xsl:attribute name="color">
					<xsl:value-of select="@COLOR"/>
				</xsl:attribute>
			</xsl:if>
			<xsl:if test="@SIZE">
				<xsl:attribute name="size">
					<xsl:value-of select="@SIZE"/>
				</xsl:attribute>
			</xsl:if>
			<xsl:if test="@WIDTH">
				<xsl:attribute name="WIDTH">
					<xsl:value-of select="@WIDTH"/>
				</xsl:attribute>
			</xsl:if>

		</xsl:element>
	</xsl:template>


	<xsl:template name="CreateFrame">

		<xsl:element name="span">
			<xsl:if test="@ID">
				<xsl:attribute name="id">
					<xsl:value-of select="@ID"/>
				</xsl:attribute>
			</xsl:if>
			<xsl:if test="@WIDTH">
				<xsl:attribute name="width">
					<xsl:value-of select="@WIDTH"/>
				</xsl:attribute>
			</xsl:if>
			<xsl:choose>
				<xsl:when test="@CLASS">
					<xsl:attribute name="class">
						<xsl:value-of select="@CLASS"/>
					</xsl:attribute>
				</xsl:when>
				<xsl:when test="@ALIGN">
					<xsl:attribute name="align">
						<xsl:value-of select="@ALIGN"/>
					</xsl:attribute>
				</xsl:when>

				<xsl:otherwise>
					<xsl:if test="@STYLE">
						<xsl:attribute name="style">
							<xsl:value-of select="@STYLE"/>
						</xsl:attribute>
					</xsl:if>
				</xsl:otherwise>
			</xsl:choose>
			<xsl:value-of select="./text()"/>
		</xsl:element>
	</xsl:template>

	<xsl:template name="CreateRadio">
		<xsl:if test="@BIND and not(@CHECKED_VALUE)">
			<span style="display:none" name="DiagnoseSpan"> radio requirement violation: <br/> when
				using attribute BIND, CHECKED_VALUE are mandatory </span>
		</xsl:if>

		<xsl:element name="input">
			<xsl:attribute name="type">Radio</xsl:attribute>

			<xsl:if test="@ENABLED[.= 'false']">
				<xsl:attribute name="disabled">true</xsl:attribute>
			</xsl:if>
			<xsl:if test="@NAME[.!= '']">
				<xsl:attribute name="name">
					<xsl:value-of select="@NAME"/>
				</xsl:attribute>
			</xsl:if>
			<xsl:if test="@ID[.!= '']">
				<xsl:attribute name="id">
					<xsl:value-of select="@ID"/>
				</xsl:attribute>
			</xsl:if>
			<xsl:if test="@TOOLTIP[.!= '']">
				<xsl:attribute name="title">
					<xsl:value-of select="@TOOLTIP"/>
				</xsl:attribute>
			</xsl:if>

			<xsl:if test="@CLASS[.!= '']">
				<xsl:attribute name="class">
					<xsl:value-of select="@CLASS"/>
				</xsl:attribute>
			</xsl:if>

			<xsl:if test="@ONCLICK">
				<xsl:attribute name="onclick">
					<xsl:value-of select="@ONCLICK"/>
				</xsl:attribute>
			</xsl:if>
			<!-- bind section-->
			<xsl:variable name="pathcell">
				<xsl:choose>
					<xsl:when test="@BIND">
						<xsl:value-of select="@BIND"/>
					</xsl:when>
					<xsl:otherwise>0</xsl:otherwise>
				</xsl:choose>
			</xsl:variable>

			<xsl:variable name="datapath">
				<xsl:choose>
					<xsl:when test="contains($pathcell,'/')">
						<xsl:value-of select="substring-before($pathcell,'/')"/>
					</xsl:when>
					<xsl:otherwise>
						<xsl:value-of select="$pathcell"/>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:variable>
			<xsl:variable name="datanode" select="//*[name()=$datapath]"/>
			<xsl:if test="@CHECKED[. = 'true']">
				<xsl:attribute name="checked">true</xsl:attribute>
				<xsl:attribute name="value">1</xsl:attribute>
			</xsl:if>
			<xsl:if test="@BIND">
				<xsl:variable name="data">
					<xsl:choose>
						<xsl:when test="$pathcell != 0">
							<xsl:choose>
								<xsl:when test="contains($pathcell,'/')">

									<xsl:for-each select="$datanode">

										<xsl:call-template name="FindData">
											<xsl:with-param name="nodename">
												<xsl:value-of
												select="substring-before($pathcell,'/')"/>
											</xsl:with-param>
											<xsl:with-param name="tail">
												<xsl:value-of
												select="substring-after($pathcell,'/')"/>
											</xsl:with-param>
										</xsl:call-template>
									</xsl:for-each>
								</xsl:when>
								<xsl:otherwise> </xsl:otherwise>
							</xsl:choose>
						</xsl:when>
						<xsl:otherwise>0</xsl:otherwise>
					</xsl:choose>
				</xsl:variable>
				<xsl:if test="@CHECKED_VALUE and @CHECKED_VALUE[.=$data]">
					<xsl:attribute name="checked">true</xsl:attribute>
				</xsl:if>
				<xsl:attribute name="value">
					<xsl:value-of select="$data"/>
				</xsl:attribute>
			</xsl:if>
			<!--  end bind section -->
		</xsl:element>
	</xsl:template>

	<xsl:template name="CreateBreak">
		<xsl:element name="br">
			<xsl:if test="@CLASS[.!= '']">
				<xsl:attribute name="class">
					<xsl:value-of select="@CLASS"/>
				</xsl:attribute>
			</xsl:if>
		</xsl:element>
	</xsl:template>

	<xsl:template name="CreateHidden">
		<input type="hidden">
			<xsl:attribute name="id">
				<xsl:value-of select="@ID"/>
			</xsl:attribute>
			<xsl:choose>
				<xsl:when test="@DEFAULT_VALUE[.='']">
					<xsl:attribute name="value">
						<xsl:value-of select="@DEFAULT_VALUE"/>
					</xsl:attribute>
				</xsl:when>
				<xsl:otherwise>
					<xsl:attribute name="value">
						<xsl:call-template name="GetData"/>
					</xsl:attribute>
				</xsl:otherwise>
			</xsl:choose>
		</input>
	</xsl:template>

	<xsl:template name="CreateNOBR">
		<nobr>
			<xsl:choose>
				<xsl:when test="count(child::*)&gt;0">

					<xsl:value-of select="./text()"/>
					<xsl:for-each select="./*">
						<xsl:call-template name="buildHTML"/>
					</xsl:for-each>

				</xsl:when>
				<xsl:otherwise>
					<xsl:choose>
						<xsl:when test="$tableMode=1">
							<xsl:value-of select="./text()" disable-output-escaping="yes"/>
						</xsl:when>
						<xsl:otherwise>
							<xsl:call-template name="GetData"/>
						</xsl:otherwise>
					</xsl:choose>
				</xsl:otherwise>
			</xsl:choose>
		</nobr>
	</xsl:template>

	<xsl:template name="CreateSpan">
		<xsl:param name="data"/>
		<xsl:param name="row_pos"/>
		<xsl:param name="cell_pos"/>
		<xsl:param name="tableID"/>
		<span>
			<xsl:choose>
				<xsl:when test="$row_pos">
					<xsl:attribute name="id">
						<xsl:value-of
							select="concat('txt_',concat($cell_pos - 1,concat('_',concat(concat($row_pos - 1,'_'),$tableID))))"
						/>
					</xsl:attribute>
				</xsl:when>
				<xsl:otherwise>
					<xsl:if test="@ID[.!= '']">
						<xsl:attribute name="id">
							<xsl:value-of select="@ID"/>
						</xsl:attribute>
					</xsl:if>
				</xsl:otherwise>
			</xsl:choose>
			<xsl:if test="@CLASS">
				<xsl:attribute name="class">
					<xsl:value-of select="@CLASS"/>
				</xsl:attribute>
			</xsl:if>
			<xsl:if test="@STYLE">
				<xsl:attribute name="style">
					<xsl:value-of select="@STYLE"/>
				</xsl:attribute>
			</xsl:if>
			<xsl:if test="@ALIGN">
				<xsl:attribute name="align">
					<xsl:value-of select="@ALIGN"/>
				</xsl:attribute>
			</xsl:if>
			<xsl:if test="@TOOLTIP">
				<xsl:attribute name="tooltip">
					<xsl:value-of select="@TOOLTIP"/>
				</xsl:attribute>
			</xsl:if>
			<xsl:if test="@ONCLICK">
				<xsl:attribute name="onclick">
					<xsl:value-of select="@ONCLICK"/>
				</xsl:attribute>
			</xsl:if>
			<xsl:choose>
				<xsl:when test="$tableMode=1">
				     <xsl:choose>
					     <xsl:when test="./text()='' and @DEFAULT_VALUE[.!='']">
					        <xsl:value-of select="@DEFAULT_VALUE"/>
					     </xsl:when>
					     <xsl:otherwise>
					       <xsl:value-of select="./text()" disable-output-escaping="yes"/>
					     </xsl:otherwise>
					  </xsl:choose>
				</xsl:when>
				<xsl:when test="$data">
					<xsl:value-of select="$data"/>
				</xsl:when>
				<xsl:otherwise>
					<xsl:call-template name="GetData"/>
				</xsl:otherwise>
			</xsl:choose>
			<xsl:for-each select="./*">
				<xsl:call-template name="buildHTML"/>
			</xsl:for-each>
		</span>
	</xsl:template>

	<xsl:template name="CreatePassword">

		<input type="password">
			<xsl:if test="@CLASS">
				<xsl:attribute name="class">
					<xsl:value-of select="@CLASS"/>
				</xsl:attribute>
			</xsl:if>
			<xsl:if test="@STYLE">
				<xsl:attribute name="style">
					<xsl:value-of select="@STYLE"/>
				</xsl:attribute>
			</xsl:if>
			<xsl:if test="@ID">
				<xsl:attribute name="id">
					<xsl:value-of select="@ID"/>
				</xsl:attribute>
			</xsl:if>
			<xsl:if test="@MAXLENGTH">
				<xsl:attribute name="maxlength">
					<xsl:value-of select="@MAXLENGTH"/>
				</xsl:attribute>
			</xsl:if>

			<xsl:if test="@READONLY[.= 'true']">
				<xsl:attribute name="readonly">
					<xsl:value-of select="@READONLY"/>
				</xsl:attribute>
			</xsl:if>
			<xsl:choose>
				<xsl:when test="(@BIND and @SUBMIT[.='true'])or @VALID_TYPE">
					<xsl:attribute name="onchange">
						<xsl:choose>
							<xsl:when test="@ONCHANGE">
								<xsl:value-of select="@ONCHANGE"/>;<xsl:call-template
									name="CreateControlManager"/>
							</xsl:when>
							<xsl:otherwise>
								<xsl:call-template name="CreateControlManager"/>
							</xsl:otherwise>
						</xsl:choose>
					</xsl:attribute>
				</xsl:when>
				<xsl:otherwise>
					<xsl:if test="@ONCHANGE">
						<xsl:attribute name="onchange">
							<xsl:value-of select="@ONCHANGE"/>
						</xsl:attribute>
					</xsl:if>
				</xsl:otherwise>
			</xsl:choose>

			<xsl:attribute name="value">
				<xsl:call-template name="GetData"/>
			</xsl:attribute>

		</input>

	</xsl:template>

	<xsl:template name="CreateInputFile">
		<xsl:element name="input">
			<xsl:attribute name="type">file</xsl:attribute>
			<xsl:if test="@ID">
				<xsl:attribute name="id">
					<xsl:value-of select="@ID"/>
				</xsl:attribute>
			</xsl:if>
			<xsl:if test="@CLASS">
				<xsl:attribute name="class">
					<xsl:value-of select="@CLASS"/>
				</xsl:attribute>
			</xsl:if>
			<xsl:if test="@ALIGN">
				<xsl:attribute name="align">
					<xsl:value-of select="@ALIGN"/>
				</xsl:attribute>
			</xsl:if>
			<xsl:if test="@STYLE">
				<xsl:attribute name="style">
					<xsl:value-of select="@STYLE"/>
				</xsl:attribute>
			</xsl:if>
			<xsl:if test="@WIDTH">
				<xsl:attribute name="width">
					<xsl:value-of select="@WIDTH"/>
				</xsl:attribute>
			</xsl:if>
			<xsl:if test="@HEIGHT">
				<xsl:attribute name="height">
					<xsl:value-of select="@HEIGHT"/>
				</xsl:attribute>
			</xsl:if>
			<xsl:if test="@ONFILTERCHANGE">
				<xsl:attribute name="onfilterchange">
					<xsl:value-of select="@ONFILTERCHANGE"/>
				</xsl:attribute>
			</xsl:if>
			<xsl:if test="@ONCLICK">
				<xsl:attribute name="onclick">
					<xsl:value-of select="@ONCLICK"/>
				</xsl:attribute>
			</xsl:if>
			<xsl:if test="@VALUE">
				<xsl:value-of select="./text()"/>
			</xsl:if>

		</xsl:element>
	</xsl:template>

	<xsl:template name="CreateFieldset">
		<fieldset>
			<xsl:if test="@ID">
				<xsl:attribute name="id">
					<xsl:value-of select="@ID"/>
				</xsl:attribute>
			</xsl:if>
			<xsl:if test="@CLASS">
				<xsl:attribute name="class">
					<xsl:value-of select="@CLASS"/>
				</xsl:attribute>
			</xsl:if>
			<xsl:if test="@ALIGN">
				<xsl:attribute name="align">
					<xsl:value-of select="@ALIGN"/>
				</xsl:attribute>
			</xsl:if>
			<xsl:if test="@STYLE">
				<xsl:attribute name="style">
					<xsl:value-of select="@STYLE"/>
				</xsl:attribute>
			</xsl:if>
			<xsl:for-each select="./*">
				<xsl:call-template name="buildHTML"> </xsl:call-template>
			</xsl:for-each>
		</fieldset>
	</xsl:template>

	<xsl:template name="CreateLegend">
		<legend>
			<xsl:if test="@STYLE">
				<xsl:attribute name="style">
					<xsl:value-of select="@STYLE"/>
				</xsl:attribute>
			</xsl:if>
			<xsl:if test="@CLASS">
				<xsl:attribute name="class">
					<xsl:value-of select="@CLASS"/>
				</xsl:attribute>
			</xsl:if>
			<xsl:if test="@ALIGN">
				<xsl:attribute name="align">
					<xsl:value-of select="@ALIGN"/>
				</xsl:attribute>
			</xsl:if>
			<xsl:for-each select="./*">
				<xsl:call-template name="buildHTML"/>
			</xsl:for-each>
		</legend>
	</xsl:template>

	<xsl:template name="CreateButton">

		<xsl:choose>
			<xsl:when test="@SRC">
				<xsl:element name="IMG">
					<xsl:if test="@CLASS">
						<xsl:attribute name="class">
							<xsl:value-of select="@CLASS"/>
						</xsl:attribute>
					</xsl:if>
					<xsl:if test="@STYLE">
						<xsl:attribute name="style">
							<xsl:if test="@STYLE"/>
						</xsl:attribute>
					</xsl:if>
					<xsl:if test="@ID">
						<xsl:attribute name="id">
							<xsl:if test="@ID"/>
						</xsl:attribute>
					</xsl:if>
					<xsl:if test="@NAME">
						<xsl:attribute name="name">
							<xsl:if test="@NAME"/>
						</xsl:attribute>
					</xsl:if>
					<xsl:attribute name="SRC">
						<xsl:value-of select="@SRC"/>
					</xsl:attribute>
					<xsl:if test="@SRC_OVER[.!= '']">
						<xsl:attribute name="onmouseover">javascript:this.src="<xsl:value-of
								select="@SRC_OVER"/>"</xsl:attribute>
						<xsl:attribute name="onmouseout">javascript:this.src="<xsl:value-of
								select="@SRC"/>"</xsl:attribute>
					</xsl:if>
					<xsl:if test="@SRC_DOWN[.!= '']">
						<xsl:attribute name="onmousedown">javascript:this.src="<xsl:value-of
								select="@SRC_DOWN"/>"</xsl:attribute>
					</xsl:if>
					<xsl:if test="@TOOLTIP">
						<xsl:attribute name="title">
							<xsl:value-of select="@TOOLTIP"/>
						</xsl:attribute>
					</xsl:if>
					<xsl:if test="@ENABLED[.= 'false']">
						<xsl:attribute name="disabled">true</xsl:attribute>
					</xsl:if>
					<xsl:if test="@ONCLICK">
						<xsl:attribute name="ONCLICK">javascript:<xsl:value-of select="@ONCLICK"
						/></xsl:attribute>
					</xsl:if>

				</xsl:element>
			</xsl:when>
			<xsl:otherwise>
				<xsl:element name="button">

					<xsl:if test="@STYLE">
						<xsl:attribute name="style">
							<xsl:value-of select="@STYLE"/>
						</xsl:attribute>
					</xsl:if>
					<xsl:if test="@ID">
						<xsl:attribute name="id">
							<xsl:value-of select="@ID"/>
						</xsl:attribute>
					</xsl:if>
					<xsl:if test="@NAME">
						<xsl:attribute name="name">
							<xsl:value-of select="@NAME"/>
						</xsl:attribute>
					</xsl:if>
					<xsl:if test="@VALUE">
						<xsl:attribute name="value">
							<xsl:value-of select="@VALUE"/>
						</xsl:attribute>
					</xsl:if>
					<xsl:if test="@TOOLTIP">
						<xsl:attribute name="title">
							<xsl:value-of select="@TOOLTIP"/>
						</xsl:attribute>
					</xsl:if>
					<xsl:if test="@ENABLED[.= 'false']">
						<xsl:attribute name="disabled">true</xsl:attribute>
					</xsl:if>
					<xsl:if test="@WIDTH">
						<xsl:attribute name="width">
							<xsl:value-of select="@WIDTH"/>
						</xsl:attribute>
					</xsl:if>
					<xsl:if test="@HEIGHT">
						<xsl:attribute name="height">
							<xsl:value-of select="@HEIGHT"/>
						</xsl:attribute>
					</xsl:if>
					<xsl:if test="@ONCLICK">
						<xsl:attribute name="onclick">
							<xsl:value-of select="@ONCLICK"/>
						</xsl:attribute>
					</xsl:if>
					<xsl:value-of select="./text()"/>
				</xsl:element>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<xsl:template name="CreateUnderline">
		<u>
			<xsl:value-of select="./text()"/>
			<xsl:for-each select="./*">
				<xsl:call-template name="buildHTML"/>
			</xsl:for-each>
		</u>
	</xsl:template>




	<xsl:template name="CreateMaster">
		<xsl:for-each select="./*">
			<xsl:call-template name="buildHTML"/>
		</xsl:for-each>
	</xsl:template>

	<!--customer templates -->

	<xsl:template name="CreatePagerHolder">
		<xsl:element name="table">
			<xsl:attribute name="id">
				<xsl:value-of select="@ID"/>
			</xsl:attribute>
			<xsl:if test="@CLASS">
				<xsl:attribute name="class">
					<xsl:value-of select="@CLASS"/>
				</xsl:attribute>
			</xsl:if>
			<tr>
				<td/>
			</tr>
		</xsl:element>
	</xsl:template>

	<xsl:template name="CreateBitMaskHolder">
		<xsl:for-each select="./*">
			<xsl:call-template name="buildHTML"/>
		</xsl:for-each>
	</xsl:template>




	<!-- ****customer templates****   end -->

</xsl:stylesheet>
