function Lister(table_id, width, additional_params)
{
this._id = table_id;
this._width = typeof(width)=="undefined" ? "100%" : width;
this._additional_params = typeof(additional_params)=="undefined" ? "" : additional_params;
this._columns = new Array();
this._row = new Array();
this._rowCount = 0;
this.enumerate = false;
}
Lister.prototype.setEnumerate = function()
{
this.enumerate = true;
}
Lister.prototype.addColumn = function(data, width, align)
{
this._columns[this._columns.length] = new Array(data, width, align);
}
Lister.prototype.setColumn = function(index, data)
{
this._row[index] = data;
}
Lister.prototype.getHeader = function()
{
var columns = this._columns.length;
var content = "<table id='"+this._id+"' border='0' cellspacing='0' cellpadding='0' width='"+this._width+"'>\n";
content += "<tr>\n";
content += " <td width='10' height='10'><img width='10' height='10' src='../Images/tl.gif'></td>\n";
content += " <td colspan="+( columns + (this.enumerate ? 1 : 0))+" width='100%' class='data-area-canvas'></td>\n";
content += " <td width='10' height='10'><img width='10' height='10' src='../Images/tr.gif'></td>\n";
content += "</tr>\n";
content += "<tr valign='bottom'>\n";
content += " <td width='10' class='data-area-canvas'></td>\n";
if ( this.enumerate )
{
content += " <td class='lister-header' width='20' style='font-weight: bold;'>&nbsp;</td>\n";
}
for ( var i = 0; i < columns; i++ )
{
content += "<td class='lister-header' " + (this._columns[i][1] != "" ? "width='" + this._columns[i][1] + "'" : "")+ " align='" + this._columns[i][2] + "' >" + this._columns[i][0] + "</td>\n";
}
content += " <td width='10' class='data-area-canvas'></td>\n";
content += "</tr>\n";
document.write(content);
}
Lister.prototype.getRow = function()
{
this._rowCount++;
var columns = this._columns.length;
var content = "";
content += "<tr>\n";
content += " <td height='24' class='data-area-canvas'></td>\n";
if ( this.enumerate )
{
content += " <td class='data-area-canvas' width='20' style='font-weight: bold;'>"+this._rowCount+"</td>\n";
}
for ( var i = 0; i < columns; i++ )
{
content += "<td class='"+( !(this._rowCount%2) ? "data-area-canvas" : "data-area-canvas-odd" )+"' " + (this._columns[i][1] != "" ? "width='" + this._columns[i][1] + "'" : "")+ " align='" + this._columns[i][2] + "'>" + (this._row[i] ? this._row[i] : "&nbsp;") + "</td>\n";
}
content += " <td nowrap class='data-area-canvas'></td>\n";
content += "</tr>\n";
document.write(content);
}
Lister.prototype.getFooter = function()
{
var columns = this._columns.length;
var content = "";
content += "<tr>";
content += " <td class='data-area-canvas' width='10' height='10'><img width='10' height='10' src='../Images/bl.gif'></td>";
content += " <td colspan="+( columns + (this.enumerate ? 1 : 0))+" class='data-area-canvas'></td>";
content += " <td class='data-area-canvas' width='10' height='10'><img width='10' height='10' src='../Images/br.gif'></td>";
content += "</tr>";
content += "</table>";
document.write(content);
}
