var TKN_CONST=1
var TKN_DICT_ITEM=2
var TKN_DATE_TIME=3
var TKN_DATE=4
var TKN_TIME=5
var TKN_NUMBER=6
var TKN_CALLBACK=7
var TKN_DATE_SHORT_TIME=8
var TKN_SHORT_TIME=9
function PageTokens(id,page)
{
this.id = id;
this.page = page;
this.error = null;
var pageTokenArr = new Array();
var localization = getTopApp().localization;
localization.addPage(this);
this.init = function(LangSelector)
{
var ret=true;
localization.fun="pageTokens.init";
if (localization.ENABLED){
translatePage();
if (LangSelector){
if (!LangSelector.placeHolderId||!document.getElementById(LangSelector.placeHolderId)) {
this.error = localization.trc.setError("LngSelParamErr");
return false;
}
ret=localization.createLangSelector(document.getElementById(LangSelector.placeHolderId),LangSelector);
this.error=(!ret)? localization.error : null;
}
}
return ret;
};
var Token = function (domId, dictId, dictObj, paramList)
{
this.id = domId;
this.dictId = dictId;
this.domObj = null;
this.dictObj = dictObj;
this.paramList = paramList;
this.attrList = null;
};
Token.prototype.translate = function()
{
var attrName="";
try {
localization.fun="Token.translate"+((this.id)?" ["+this.id+"]":"");
if (!this.domObj)
this.domObj=document.getElementById(this.id);
if ((!this.domObj)&&(!this.dictId)&&(this.paramList)) {
var tmp=localization.lngMg.getText(this.dictId,this.paramList);
return;
}
if (this.domObj){
if ((this.dictId)||(this.paramList))
updateDomObj(this.domObj,localization.lngMg.getText(this.dictId,this.paramList))
if (this.attrList) {
for (var attrName in this.attrList) {
localization.fun="Token.translate"+" ["+this.id+"."+attrName+"]";
var attrValue = localization.lngMg.getText(this.attrList[attrName].attrDictId, this.attrList[attrName].attrParamList);
this.domObj[attrName]=attrValue;
}
}
}
}
catch(err){
var errObj = localization.trc.setError("TknTransErr",[this.id+"."+attrName]);
}
};
Token.prototype.write = function() {
if (this.dictId!=null)
document.write(dictionaries.gettext(this.dictId,this.paramList));
};
this.setToken = function(domId, dictId, paramList)
{
var mess="";
var dictObj;
localization.page=this.page;
localization.fun="setToken ["+domId+"]";
if (!localization.ENABLED) return;
if (dictId) {
if (!localization.lngMg.isDictItemExist(dictId)) {
this.error = localization.trc.setError("DINotFound",[dictId]);
return false;
}
}
if (paramList) {
mess=CheckParamList(paramList);
if (mess!="") {
this.error = localization.trc.setError("TknParErr",[mess]);
return false;
}
}
var token = new Token(domId, dictId, dictObj, paramList);
pageTokenArr[domId]=token;
token.translate();
return true;
};
this.setServerMessageToken = function(domId,dictId,text,paramList)
{
var mess="";
var dictObj;
var patt0 = new RegExp("\\b\\d+[.,]?\\d*","g");
localization.page=this.page;
localization.fun="setServerMessageToken ["+domId+"]";
if (!localization.ENABLED) return;
if (!localization.lngMg.addDefaultDictionaryItem(dictId, text)) {
this.error = localization.error;
return false;
}
if (paramList) {
var paramType;
var tokenParamList = new Array();
for (var i=0; i<paramList.length; i++) {
paramType = TKN_CONST;
if (!isNaN(paramList[i]))
if (patt0.test(paramList[i]))
paramType = TKN_NUMBER;
var newParam = new Array();
newParam[0]= paramType;
newParam[1]=paramList[i];
tokenParamList[i]=newParam;
}
mess=CheckParamList(tokenParamList);
if (mess!="") {
this.error = localization.trc.setError("TknParErr",[mess]);
alert("mess="+mess);
return false;
}
}
else {
this.error = localization.trc.setError("TknParMiss");
return false;
}
var token = new Token(domId, dictId, dictObj, tokenParamList);
pageTokenArr[domId]=token;
token.translate();
return true;
};
this.setTokenAttribute = function(domId, attrName, dictId, paramList)
{
if (!localization.ENABLED) return;
localization.page=this.page;
localization.fun="setTokenAttribute ["+domId+"."+attrName+"]";
if (!pageTokenArr[domId]) {
this.error = localization.trc.setError("TknNotExist",[domId]);
return false;
}
if (dictId&&(!localization.lngMg.isDictItemExist(dictId))) {
this.error = localization.trc.setError("DINotFound",[dictId]);
return false;
}
if (paramList) {
mess=CheckParamList(paramList);
if (mess!="") {
this.error = localization.trc.setError("TknParErr",mess);
return false;
}
}
var token = pageTokenArr[domId];
if (!token.attrList)
token.attrList = new Array();
token.attrList[attrName]= new TokenAttribute(attrName, dictId, paramList);
if (token.domObj) {
try {
var attrValue = localization.lngMg.getText(dictId, paramList);
token.domObj[attrName]=attrValue;
}
catch(err){
this.error = localization.trc.setError("TknAttrTransErr");
return false;
}
}
return true;
};
var TokenAttribute = function (attrName, attrDictId, attrParamList)
{
this.attrName = attrName;
this.attrDictId = attrDictId;
this.attrParamList = attrParamList;
};
this.removeTokenAttribute = function(domId, attrName)
{
if (!localization.ENABLED) return;
localization.page=this.page;
localization.fun="removeTokenAttribute ["+domId+"."+attrName+"]";
if (!pageTokenArr[domId]) {
this.error = localization.trc.setError("TknNotExist",[domId]);
return false;
}
else {
var token = pageTokenArr[domId];
token.attrList[attrName]= null;
}
return true;
};
this.removeToken = function(domId) {
if (!localization.ENABLED) return;
pageTokenArr[domId]=null
};
this.translate = function(lngSelContainer) {
translatePage()
};
this.getDictItemSeverity = function(hashKey) {
return localization.lngMg.getDictItemSeverity(hashKey)
}
this.getActiveDateFormat = function() {
return localization.lngMg.getActiveDateFormat();
};
this.getActiveTimeFormat = function() {
return localization.lngMg.getActiveTimeFormat();
};
this.getActiveDateTimeFormat = function() {
return localization.lngMg.getActiveDateFormat()+" "+localization.lngMg.getActiveTimeFormat();
};
this.getActiveNumberFormat = function() {
return localization.lngMg.getActiveNumberFormat();
};
this.getLocalLangSysName = function() {
return localization.lngMg.getLocalLangSysName();
};
this.getActiveDecimalDelim = function() {
return localization.lngMg.getActiveDecimalDelim();
}
this.getActiveDigitGroupDelim = function() {
return localization.lngMg.getActiveDigitGroupDelim();
}
this.getActiveShortBtnPercentage = function() {
return localization.lngMg.getActiveShortBtnPercentage();
}
this.getActiveLongBtnPercentage = function() {
return localization.lngMg.getActiveLongBtnPercentage();
}
this.createDateObject = function(dateStr, dateFormat) {
return localization.lngMg.createDateObject(dateStr, dateFormat)
};
this.createNumberObject = function(paramValue) {
var ret=localization.lngMg.createNumberObject(paramValue)
if (!ret) this.error = localization.error;
return ret;
};
this.addDefaultDictionaryItem = function(itemId, itemText) {
localization.lngMg.addDefaultDictionaryItem(itemId, itemText);
};
this.langReload = function() {
localization.langReload();
};
this.getText = function(dictId, paramList) {
return localization.lngMg.getText(dictId, paramList);
};
this.destroy = function() {
if (!localization.ENABLED) return;
try {localization.removePage(this.id);}
catch(err){}
};
function CheckParamList(paramList) {
var arrTypes = new Array("","TKN_CONST","TKN_DICT_ITEM","TKN_DATE_TIME","TKN_DATE","TKN_TIME","TKN_NUMBER","TKN_CALLBACK","TKN_DATE_SHORT_TIME","TKN_SHORT_TIME");
var ok=true;
var mess="";
for (var i=0; i<paramList.length; i++) {
if (typeof(paramList[i][1])=='string')
paramList[i][1]=paramList[i][1].replace(/&nbsp;/g," ");
switch (paramList[i][0]) {
case TKN_CONST: {ok=(paramList[i][1]); break;}
case TKN_DICT_ITEM: {ok=(localization.lngMg.isDictItemExist(paramList[i][1])); break;}
case TKN_DATE_SHORT_TIME:
case TKN_SHORT_TIME:
case TKN_DATE_TIME:
case TKN_DATE:
case TKN_TIME: {
if (!(null!=paramList[i][1] && 'object'==typeof(paramList[i][1])))
paramList[i][1]=localization.lngMg.createDateObject(paramList[i][1],paramList[i][2]);
ok =((paramList[i][1])&&(!isNaN(paramList[i][1].getFullYear()))); break;
}
case TKN_NUMBER: {ok=(!isNaN(paramList[i][1])); break;}
case TKN_CALLBACK: {ok=('function'==typeof(paramList[i][1])||'object'==typeof(paramList[i][1]));break;}
default: {mess="Unknown parameter type"; break;}
}
if (!ok) {
mess="Invalid token parameter. Type: "+arrTypes[paramList[i][0]]+ ".Value: "+paramList[i][1]+ ".Type: "+typeof(paramList[i][1]);
break;
}
}
return mess;
}
function translatePage() {
for (var i in pageTokenArr)
if (pageTokenArr[i])
try {pageTokenArr[i].translate();}
catch(err){pageTokenArr[i]=null;};
}
function getTopApp() {
var _top = top;
if (_top.localization){
return _top;
}
if (opener) {
if (opener.top)
if (opener.top.localization)
return opener.top;
if (opener.opener) {
if (opener.opener.top)
if (opener.opener.top.localization)
return opener.opener.top;
if (opener.opener.opener) {
if (opener.opener.opener.top)
if (opener.opener.opener.top.localization)
return opener.opener.opener.top;
}
}
};
if (!(_top.localization)) {
for (var i=0; i<_top.frames.length; i++) {
if (_top.frames[i].localization){
_top = _top.frames[i];
break;
}
}
};
return _top;
}
function updateDomObj(domObj, tranStr)
{
if (domObj) {
if (domObj.nodeName=='OPTION')
domObj.text=tranStr;
else
domObj.innerHTML=tranStr;
}
}
};
